﻿<%--<%@ OutputCache Duration="864000" VaryByHeader="Host" VaryByParam="none" Location="any"%>--%>
<%@ Page language="C#" %>
<%@ Import Namespace="CardioLog.API" %>
<%
	Response.ContentType = "text/x-component";
    
    double controlHeightOneColTable;
    double controlHeightTwoColTable;

    double controlWidthOneColTable;
    double controlWidthTwoColTable;

    if (!double.TryParse(CardioLog.API.GlobalSettings.Get(CardioLog.API.Prefs.GENERAL_SETTINGS, CardioLog.API.Prefs.GS_CONTROL_HEIGHT_ONE_COL_TABLE), out controlHeightOneColTable))
        controlHeightOneColTable = 1;
    if (!double.TryParse(CardioLog.API.GlobalSettings.Get(CardioLog.API.Prefs.GENERAL_SETTINGS, CardioLog.API.Prefs.GS_CONTROL_HEIGHT_TWO_COL_TABLE), out controlHeightTwoColTable))
        controlHeightTwoColTable = 1;

    if (!double.TryParse(CardioLog.API.GlobalSettings.Get(CardioLog.API.Prefs.GENERAL_SETTINGS, CardioLog.API.Prefs.GS_CONTROL_WIDTH_ONE_COL_TABLE), out controlWidthOneColTable))
        controlWidthOneColTable = 1;
    if (!double.TryParse(CardioLog.API.GlobalSettings.Get(CardioLog.API.Prefs.GENERAL_SETTINGS, CardioLog.API.Prefs.GS_CONTROL_WIDTH_TWO_COL_TABLE), out controlWidthTwoColTable))
        controlWidthTwoColTable = 1;
    
%>
<html xmlns:v="urn:schemas-microsoft-com:vml" xmlns:CARDIOLOG>
<head>
    <title></title>
	<link rel="stylesheet" type="text/css" href="/CardioLog/styles/2010_general.css"></link>
	<link rel="stylesheet" type="text/css" href="/CardioLog/Styles/ControlsCommon.css"></link>
	<meta http-equiv="content-type" content="text/html; charset=utf-8">
	<PUBLIC:COMPONENT tagName=REPORT>
		<PUBLIC:ATTACH event="oncontentready" onevent="init()"/>

		<PUBLIC:METHOD name="setParent"/>
		<PUBLIC:METHOD name="refresh"/>
		<PUBLIC:METHOD name="fetch"/>
		<PUBLIC:METHOD name="buildTable"/>
		<PUBLIC:METHOD name="setHeight"/>

		<PUBLIC:METHOD name="getTitle"/>

		<PUBLIC:METHOD name="register"/>
		<PUBLIC:METHOD name="schedule"/>
	
		<PUBLIC:METHOD name="getResults"/>
		
		<PUBLIC:PROPERTY name="cid" put="setCID" get="getCID"/>
		
		<PUBLIC:METHOD name="setCached"></PUBLIC:METHOD>
	</PUBLIC:COMPONENT>
	<script language="JScript">
		
        top.document._GLOBALCOL = element.sizeState;
	    element.from = 0;
		element.to = 0;
		element.total = 0;
		element.loading = false;
		
		var cid = false;
		var call = "";
		var prefs = "";
		var freq = 8640000;
		var data = "";
		var type = "";

		element.params = new Array();
		element.dataViewer = "";
		
		element.schedulerWaiting = false;

		function setCID(value) { cid = value; }
		function getCID() { return cid; }

		function setCached(cached) {
			element.parent.cached = (cached == "True") ? true : false;
			element.parent.updateLayers();
		}
		
		function setParent() {
			try {
				var parent = element.parentElement;
				while (parent.tagName != "BODY") {
					parent = parent.parentElement;
					if (parent.id == "cardioLogBox") {
						element.parent = parent;
						element.parent.type = "report";
						return true;
					}
				}
			} catch (e) {
			}
			element.parent = null;
			return false;
		}
		
		function init() {
			defaults.viewLink = document;
			defaults.viewInheritStyle = false;

			initPost();
		}

		var runonce = false;
		
		function initPost() {
		
			if (runonce) return;
			runonce = true;

			element.enableSelection = (element.enableSelection && element.enableSelection == "true") ? true : false;
			if (element.liquid) {
				document.all["mainTable"].style.width = "100%";
				document.all["mainTable"].style.height = "100%";
			}
			
			element.dataViewer = element.outerHTML;

			setParent();

            var widthScreen = (element.width) ? element.width : (parseInt(element.document.body.offsetWidth,10)) / element.sizeState;
            var heightScreen = (element.height) ? element.height : widthScreen*0.6;
            
            var width;
            var height;
            if ( (heightScreen +'').indexOf('%') < 0 ){
			    if ( element.sizeState == 1 && insideCardiologEnvironment())
                {
                    width = <%=controlWidthOneColTable%>;
                    height = <%=controlHeightOneColTable%>;
                    document.all["mainTable"].height = height > 1 ? height : heightScreen * height ;
			        if(width != 1)
                        document.all["mainTable"].width = width > 1 ? width : widthScreen * width ;
                    //added to fix white space on right side of table:
                    else
                    {
                        document.all["mainTable"].width = widthScreen-50;
                    }
                }
                else if ( element.sizeState == 2 && insideCardiologEnvironment() && <%=controlHeightTwoColTable%> > 1)
                {
                    width = <%=controlWidthTwoColTable%>;
                    height = <%=controlHeightTwoColTable%>;
                    //if(height > 1)
                    //{
						document.all["mainTable"].width = widthScreen-31;
                        document.all["mainTable"].height = height > 1 ? height : heightScreen * height;
                    //}
                }
                else    
                {
            	    document.all["mainTable"].height = heightScreen - 29;
                }
            
                if(insideCardiologEnvironment())
                    document.all["mainTable"].height = Math.min(document.all["mainTable"].height, <%=CardioLog.API.GlobalSettings.MaxHeightOfControls%>);
            }
			cid = (element.cid) ? element.cid : "-1";

			for (var i=0;i<element.children.length;i++) {
				element.params[element.children(i).tagName] = element.children(i).innerHTML;
			}
			for (var i=element.children.length-1;i>=0;i--) element.children(i).removeNode(true);
			
			prefs = (element.params["Prefs"]) ? element.params["Prefs"] : "<prefs />";

            prefs = handleInvalidChars(prefs);

            getEntityId(prefs);

			freq = (element.params["Freq"]) ? parseInt(element.params["Freq"],10) : 86400;

			element.style.height = "100%";

			var html = element.innerHTML.replace(/ /, "");
			
			if (html != "") this.buildTable();
			if (element.schedulerWaiting) {
				schedule(element.schedulerWaiting);
				element.schedulerWaiting = false;
			}
		}

        function handleInvalidChars(prefs) {
            //entityname
            prefs = prefs.replace(/<entityname>([^<]*)<\/entityname>/ig, function (match) { return "<entityname>" + match.toString().substring(12, match.toString().length - 13).replace(/\"/g, "″") + "</entityname>"; })
            prefs = prefs.replace(/<entityname>([^<]*)<\/entityname>/ig, function (match) { return "<entityname>" + match.toString().substring(12, match.toString().length - 13).replace(/\'/g, "′") + "</entityname>"; })

            //ctitle
            prefs = prefs.replace(/<ctitle>([^<]*)<\/ctitle>/ig, function (match) { return "<ctitle>" + match.toString().substring(8, match.toString().length - 9).replace(/\"/g, "″") + "</ctitle>"; })
            prefs = prefs.replace(/<ctitle>([^<]*)<\/ctitle>/ig, function (match) { return "<ctitle>" + match.toString().substring(8, match.toString().length - 9).replace(/\'/g, "′") + "</ctitle>"; })
			
			prefs = prefs.replace(/\"/g, "'");
			prefs = prefs.replace(/([a-z]+=)([^\s'>]+)/gi,"$1'$2'");

			var prefurl = prefs.match(/\<entityurl\>.+\<\/entityurl'?\>/gi);
			if (prefurl!=null) {
				prefurl = prefurl.toString();
				var fixedPrefUrl = prefurl.replace(/'/g,"");
				prefs = prefs.replace(prefurl, fixedPrefUrl);
			}
            // Fix URL in name (website tree)
            var prefname = prefs.match(/\<entityname\>.+\<\/entityname'?\>/gi);
			if (prefname != null) {
				prefname = prefname.toString();
				var fixedPrefName = prefname.replace(/'/g,"");
				prefs = prefs.replace(prefname, fixedPrefName);
                // replace &amp; to & in name (portal item filter)
                prefs = prefs.replace(/\&amp;/g, "&");
			}	 
            return prefs;
        }
		
        function getEntityId(prefs) {
			var entityIdMatch = prefs.match(/<entityId>([^<]*)<\/entityId>/i);
			if (entityIdMatch) element.entityId = entityIdMatch[1];
            if (typeof(element.entityId) == "undefined" || element.entityId == "static" || element.entityId == "") element.entityId = element.document.EntityId;
            else element.entityId = element.entityId.replace(/^[0-9]\:/, "");
        }
        
        function getCategoryId(prefs) {
            var categoryIdMatch = prefs.match(/<categoryId>([^<]*)<\/categoryId>/i);
			if (categoryIdMatch) categoryIdMatch = categoryIdMatch[1];
            else {
                // get category id for active user categories drilldown
                categoryIdMatch = prefs.match(/<customparam0.*>([^<]*)<\/customparam0>/i);
                if (categoryIdMatch) {
                    categoryIdMatch = categoryIdMatch[1];
                }
            }
            return categoryIdMatch;
        }
        
        function getSEOCrawlId(prefs) {
			var crawlIdMatch = prefs.match(/(<customparam0 )(.*)(\>)([^<]*)(<\/customparam0>)/i);
			if (crawlIdMatch) crawlIdMatch = crawlIdMatch[4];
            return crawlIdMatch;
        }
        
        function getTimeframe(prefs) {
            if (scheduler.getPropertyByName("timeframe"))
                return scheduler.getPropertyByName("timeframe")[0];
            else {
                var timeframeMatch = prefs.match(/<timeframe>([^<]*)<\/timeframe>/i);
			    if (timeframeMatch) timeframeMatch = timeframeMatch[1];
			    return timeframeMatch;
			}
        }
        
        function getTimeframeStart(prefs) {
			if (scheduler.getPropertyByName("timeframe_start"))
			    return scheduler.getPropertyByName("timeframe_start")[0];
			else {
			    var timeframeMatch = prefs.match(/<timeframe_start>([^<]*)<\/timeframe_start>/i);
			    if (timeframeMatch) timeframeMatch = timeframeMatch[1];
			    return timeframeMatch;
			}
        }
        
         function getTimeframeEnd(prefs) {
            if (scheduler.getPropertyByName("timeframe_end"))
                return scheduler.getPropertyByName("timeframe_end")[0];
            else {
                var timeframeMatch = prefs.match(/<timeframe_end>([^<]*)<\/timeframe_end>/i);
			    if (timeframeMatch) timeframeMatch = timeframeMatch[1];
			    return timeframeMatch;
			}
        }
        
        function getTimeInterval(prefs) {
            if (scheduler.getPropertyByName("timeinterval"))
                return scheduler.getPropertyByName("timeinterval")[0];
            else {
                var timeintervalMatch = prefs.match(/<timeinterval>([^<]*)<\/timeinterval>/i);
			    if (timeintervalMatch) timeintervalMatch = timeintervalMatch[1];
			    return timeintervalMatch;
			}	
        }
        
        function getPrefsPropertyValue(prefs, property) {
		    if (scheduler.getPropertyByName(property))
                return scheduler.getPropertyByName(property)[0];
            else {
                var propMatch = prefs.match("/<"+property+">([^<]*)<\/"+property+">/i");
			    if (propMatch) propMatch = propMatch[1];
			    return propMatch;
			}	
        }
        
		function setHeight(height) {
//			document.all["mainTable"].style.height = document.body.offsetHeight;
		}
		
		function fetch(scheduler) {
			var currentData = scheduler.getData(cid);
			if (currentData) refresh(currentData);
		}
		
		function register(scheduler) {
			element.scheduler = scheduler;
			var numOfRowsToGet = Math.round(parseInt(document.all["resultsDiv"].clientHeight, 10)/20);
			if (numOfRowsToGet == 0) numOfRowsToGet = 14;

			scheduler.register(cid, prefs, freq, refresh, "Report", element, {from:0, to:numOfRowsToGet*3});
		}
		
		function schedule(scheduler) {
			element.scheduler = scheduler;
			var numOfRowsToGet = Math.round(parseInt(document.all["resultsDiv"].clientHeight, 10)/20);
			if (numOfRowsToGet == 0) numOfRowsToGet = 14;

			if (cid && prefs != "") scheduler.register(cid, prefs, freq, refresh, "Report", element, {from:0, to:numOfRowsToGet*3});
			else element.schedulerWaiting = scheduler;
		}
		
		function refresh(data) {
			try {
				if (!runonce) {
					window.setTimeout(function() { refresh(data); }, 1000);
					return;
				} 
                var error = data.selectSingleNode(".//error");
                if (error) {
                    showError(error.text);
                    return;
                }
				prefs = (data.selectSingleNode(".//prefs")) ? data.selectSingleNode(".//prefs").xml : prefs;
				getEntityId(prefs);
				
				try{
					element.ctitle = getValue(prefs, "CTITLE", data.selectSingleNode(".//title").text);
					element.otitle = data.selectSingleNode(".//origTitle").text;
				}
				catch(e){
				}
				if (!element.parent) setParent();
				if (element.parent){
					element.parent.title = element.ctitle;
					element.parent.originalTitle = element.otitle;
				}

				clearTable();
				buildTable(data.selectSingleNode(".//data").text);
			} catch (e) {

			}
		}

		function getResults() {
			return document.all["tbody"].children;
		}
		
		function appendData(data) {
			var xmlObj = new ActiveXObject("Msxml.DOMDocument");
			xmlObj.async = false;
			xmlObj.loadXML(data.selectSingleNode(".//data").text);
			//vCodePage = "version='1.0' encoding='utf-8'"
            //pi = xmlObj.createProcessingInstruction("xml", vCodePage)

			loadResults(xmlObj.selectSingleNode(".//tbody"));
			drawResults(element.from);
			xmlObj = null;
		}
		
		var arr = new Array();
		var object = new Array();
		var vobject = new Array();
				
		function clearTable() {
			arr = new Array();
			var tbody = document.all["tbody"];
			for (var i=tbody.children.length-1;i>=0;i--) tbody.children(i).removeNode(true);
		}
		
		var columns;
		var columnsArr = new Array();
		var changeColumnWidth = -1;
		
        function showError(message) {
            var theads = document.all["thead"];
			for (var t=0;t<theads.length;t++) {
				for (var c=theads[t].children.length-1;c>=0;c--) theads[t].children(c).removeNode(true);
			}
			for (var t=0;t<theads.length;t++) {
				tr = theads[t].appendChild(document.createElement("tr"));
				tr.className = "header";

                td = tr.appendChild(document.createElement("td"));
                td.className = "error";
                td.innerHTML = message;
            }
        }
        function buildTable(xml) {
		    changeColumnWidth = -1;
			object = new Array();
			vobject = new Array();
			var xmlObj = new ActiveXObject("Msxml.DOMDocument");
			xmlObj.async = false;
			xmlObj.loadXML((xml) ? xml : "<table>"+this.innerHTML+"</table>");
			element.results = xmlObj;
			if (xmlObj.selectSingleNode("table/prefs")) {
				if (element.scheduler) element.scheduler.setPrefs(cid, xmlObj.selectSingleNode("table/prefs").xml);
			}
			if (xmlObj.parseError.errorCode != 0) {
				alert(xmlObj.parseError.reason);
			} else {
				var theads, tbody, tfoot, tr, td;
				theads = document.all["thead"];
				tfoot = document.all["tfoot"];
				if (element.footer == "false") {
					tfoot.style.display = "none";
					document.all["footerDiv"].style.borderBottom = "1px solid #7b9aad";
				}

				for (var t=0;t<theads.length;t++) {
					for (var c=theads[t].children.length-1;c>=0;c--) theads[t].children(c).removeNode(true);
				}
				for (var c=tfoot.children.length-1;c>=0;c--) tfoot.children(c).removeNode(true);
				
				columns = xmlObj.selectNodes(".//thead/td");
				
				var cols = xmlObj.selectNodes(".//columns/column");
				function notTheLastVisibleColumn(position) {
					for (var i=position+1;i<columns.length;i++) {
						if (columns[i].getAttribute("type") && columns[i].getAttribute("type") != "hidden") return true;
					}
					return false;
				}
				var qmarkData = [];
				for (var t=0;t<theads.length;t++) {
					tr = theads[t].appendChild(document.createElement("tr"));
					tr.className = "header";
					var columnPosition = -1;

					for (var i=0;i<columns.length;i++) {
						/*
						Widget heading structure
						<td>
							<nobr>
								<span>Heading text</span>
								<a>Help</a> - help section(optional - help may not exist for custom fields)
								<img/> - sorting arrow image
							</nobr>
						</td>
						*/
						var __id = (columns[i].getAttribute("id").toLowerCase().indexOf("username")>-1) ? "user" : columns[i].getAttribute("id").toLowerCase();
						if (t==0) {
							columnsArr[__id] = {text:columns[i].text, type:columns[i].getAttribute("type")};
							object[object.length] = {text:columns[i].text, type:columns[i].getAttribute("type"), id:columns[i].getAttribute("id"), maxSize:0};
							if (columns[i].getAttribute("type") != "hidden") {
							    vobject[vobject.length] = {text:columns[i].text, type:columns[i].getAttribute("type"), id:columns[i].getAttribute("id"), maxSize:0};
							}
					    }
						if (columns[i].getAttribute("type") != null && columns[i].getAttribute("type") == "hidden") {
							continue;
						} else columnPosition += 1;

						// Add a table column
						td = tr.appendChild(document.createElement("td"));
						td.className = "head";
						td.noWrap = "true";
						td.direction = (columns[i].getAttribute("direction") == null) ? -1 : columns[i].getAttribute("direction");
						td.width = columns[i].getAttribute("width");

						// Do something if the column is sortable
						if (element.sortable) {
							td.style.cursor = "hand";// Display a pointer over the column click
							td.onclick = function() {// Handle sorting on column heading click
								// The sorting may be this.children(0).children(1) or this.children(0).children(2) where there is help or there isn't one
								// this = <td> | children(0) = <nobr> | look at the structure at the begining of this "for" cycle
								var imgChild;
								for(k = 0; k<this.children(0).children.length; k++){
									if(this.children(0).children[k].tagName == "IMG")
									{
										imgChild = this.children(0).children[k];
									}
								}

								if(imgChild)
								{
									if (imgChild.src.match(/sort/)) {
										var direction = -1;
										imgChild.src = imgChild.src.replace(/(sort)([^\.]*)(\.gif)/, function (a,b,c,d) {
											if (c == "") {
												direction = 1;
												return b+"U"+d;
											} else {
												direction = -1;
												return b+d;
											}
										});
										sortTable(this.children(0).children(0).innerText, this.children(0).children(0).id, direction);
									} else {
										var nobrElement;
										for (var i=0;i<this.parentElement.children.length;i++) {
											nobrElement = this.parentElement.children[i].children(0);
											if (nobrElement && nobrElement.tagName == "NOBR") {
												for(k = 0; k<nobrElement.children.length; k++){
													if(nobrElement.children[k].tagName == "IMG")
													{
														nobrElement.children[k].src = nobrElement.children[k].src.replace(/sort[^\.]*/, "blank");
													}
												}
											}
										}

										if(imgChild.src)
											imgChild.src = imgChild.src.replace(/blank/,"sort");

										sortTable(this.children(0).children(0).innerText, this.children(0).children(0).id, -1);
									}
								}
								else
								{
								}
							}
						}
							nobr = document.createElement("nobr");
							td.appendChild(nobr);
							span = document.createElement("span");
							span.innerText = columns[i].text+" ";
							nobr.style.float = "left";
							span.id = columns[i].getAttribute("id");
							nobr.appendChild(span);

							var helpb = document.createElement("A");
							helpb.className = "qmark17";
							// Populate helplet data to object
							if (cols[i]) {
								try {
									qmarkData[columns[i].text] = cols[i].getAttribute("help");
									helpb.data = qmarkData[columns[i].text];
								} catch (e) {}
							}
							if (helpb.data) nobr.appendChild(helpb);
							helpb.onmouseover = helpMouseOverHandler;
							function helpMouseOverHandler() {
								var $ = top.jQuery;
								if (!element.parent) setParent();
								var _helpoff =  (element.parent) ? [$(element.parent).offset().left, $(element.parent).offset().top] : [450, 30];
								window.top.document.openQBubble(window, _helpoff, this, this.data);
							};
							var direction = -1;
							if (columns[i].getAttribute("direction") != null && columns[i].getAttribute("direction") == "1") direction = 1;
							img = document.createElement("img");
							if (columns[i].getAttribute("sorted") == "true") {
								element.sortColumn = columns[i].getAttribute("id");
								element.direction = columns[i].getAttribute("direction");
								img.src = element.imagesPath+"sort"+((element.direction == "-1") ? "" : "U")+".gif";
							} else img.src = element.imagesPath+"blank.gif";
							img.style.height = "8px";
							img.style.width = "5px";
							nobr.appendChild(img);
						td = document.createElement("td");
						if (notTheLastVisibleColumn(i)) tr.appendChild(td);
//						if (i<columns.length-1) tr.appendChild(td);
						td.className = "resize";
						td.position = columnPosition;
						td.innerText = " ";
						td.ondblclick = function() {
							this.startResizing = false;
							handleResize(vobject[this.position].maxSize+10, this.position);
						}
						td.onmouseup = function() {
							this.startResizing = false;
						}
						td.onmousedown = function() {
							var t = this;
							t.startResizing = true;
							window.setTimeout(function() { 
								if (!t.startResizing) return;
								pos = {x:0, y:0};
								findPosition(t.parentElement.children(t.position*2));
								resizing = {x:pos.x, col:t.position};
								
								var resizeDiv = document.all["resizeDiv"];
								resizeDiv.style.left = pos.x;
								resizeDiv.style.top = pos.y;
								resizeDiv.style.width = t.parentElement.children(t.position*2).offsetWidth+t.offsetWidth;
								resizeDiv.style.height = document.all["headTable"].offsetHeight+document.all["bodyTable"].parentElement.offsetHeight;
								resizeDiv.style.display = "";
							}, 100);
						}
						td.width = "1px";
					}
					if (t == 0) {
						td = tr.appendChild(document.createElement("td"));
						td.width = "18px";
						td.innerText = " ";
					}
					if (t == 0) {
						var cells = tr.children;
						for (var c=0;c<cells.length;c++) {
							if (cells[c].innerText.replace(/ /g, "") != "" && cells[c].offsetWidth < 10) {
								changeColumnWidth = c;
								cells[c].width = 80;
							}
						}
					} else {
						if (changeColumnWidth >= 0) tr.children[changeColumnWidth].width = 80;
					}
				}

				var error = xmlObj.selectSingleNode("./table/error");
				var results = xmlObj.selectSingleNode(".//tbody");
				
				tr = document.createElement("tr");
				tr.className = "footer";
					td = document.createElement("td");
					td.className = "foot";
					td.id = "status";
					try {
						td.colSpan = thead[0].children(0).children.length*2;
					} catch (e) {
						td.colSpan = 2;
					}
					//td.innerText = "Loaded "+element.to+" out of "+element.total;
					//td.innerText = "Found "+element.total+" results";
					td.innerText = "<%=CardioLog.API.Localization.getText("$Showing top$")%> "+element.total+" <%=CardioLog.API.Localization.getText("$rows$")%> ";
					tr.appendChild(td);
				tfoot.appendChild(tr);
				loadResults(results);
				drawTable();
				if (error != null) {
					var tr = document.createElement("tr");
					document.all["tbody"].appendChild(tr);
						var td = document.createElement("td");
						try {
							td.colSpan = thead[0].children(0).children.length*2;
						} catch (e) {
							td.colSpan = 2;
						}
						td.innerText = error.text;
						tr.appendChild(td);
						td = null;
					tr = null;
				}

			}
		}
		
		function loadResults(results) {
			if (results == null) return;
			var rows = results.selectNodes(".//tr");

			for (var i=0;i<rows.length;i++) {
				var currObject = new Object();
				for (var d=0;d<rows[i].childNodes.length;d++) {
                    currObject[object[d].text] = {text:formatValue(rows[i].childNodes[d].text, object[d].type), value:rows[i].childNodes[d].text};
				}
				arr[arr.length] = currObject;
			}
			// check if all data was loaded
			element.from = parseInt(results.getAttribute("from"),10);
			element.to = parseInt(results.getAttribute("to"),10);
			element.total = parseInt(results.getAttribute("total"),10);

			//document.all["status"].innerText = "Loaded "+element.to+" out of "+element.total;
			//document.all["status"].innerText = "Found "+element.total+" results";
			document.all["status"].innerText = "<%=CardioLog.API.Localization.getText("$Showing top$")%> "+element.total+" <%=CardioLog.API.Localization.getText("$rows$")%> ";
		}

		function formatValue(data, type) {
		
			switch (type) {
				case "text":
					return data;
				case "date":
					return data.replace(/([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})/, "$3/$2/$1 $4:$5:$6");
				default:
					return data;
			}
		}
		
		function drawTable() {
			var tbody, tr, td;
			tbody = document.all["tbody"];
			for (var i=tbody.children.length-1;i>=0;i--) tbody.children[i].removeNode(true);
			drawResults(0);
		}

		function RowOver() {
			if (!this.selected) this.className = "rowover";
		}
		function RowOut() {
			if (this.selected) this.className = "rowselected";
			else this.className = "rowout";
		}
		function RowDblClick() {
				eval(element.dblclickcallback);
		}
		function RowClick() {
			if (element.selectedItem) {
				element.selectedItem.selected = false;
				element.selectedItem.fireEvent("onmouseout");
			}
			this.className = "rowselected";
			this.selected = true;
			element.selectedItem = this;
		}
		
		function SPSPageContextClick() {
			event.returnValue = false;
			event.cancelBubble = true;
			if (element.SPSPageContextClickCallback) {
				element.SPSPageContextClickCallback(this);
			}
			return false;
		}
		
		function SPSPageClick() {
			if (element.SPSPageClickCallback) {
				event.returnValue = false;
				event.cancelBubble = true;
				element.SPSPageClickCallback(this);
			} else {
				window.open(this.title, "_blank", "");
			}
			return false;
		}
		
		var currentDDURL = "";
		var currentDDUser = "";
		var currentDDCategory = "";
        var currentDDStatusCode = "";
        var currentDDCrawlId = "";

		function doDrillDown(entry) {
			if (entry.id == "openPage") {
				window.open(currentDDURL, "_blank", "");
			} else if (entry.id == "sync") {
				window.parent.frames[0].toggleTree("managed");
				window.parent.frames[0].doSearch(currentDDURL, false);
			} else if (entry.id == "showDiagnosis") {
				window.parent.frames[0].toggleTree("managed");
				window.parent.frames[0].doSearch(currentDDURL, true);
				//parent.frames[0].toggleSearchPane(true);
			} else if (entry.id == "copyToClipboard") {
				document.getElementById("texttocopy").value = (currentDDURL == "") ? currentDDUser : currentDDURL;
				var ctc = document.getElementById("texttocopy").createTextRange();
				ctc.execCommand("Copy");
			} else {
			    // Get current control timeframe
			    var timeframe = getTimeframe(prefs);
			    var timeInterval = "";
			    var startDate = "";
			    var endDate = "";
			    if (timeframe == "0") {
			        startDate = getTimeframeStart(prefs);
			        endDate = getTimeframeEnd(prefs);
			        timeInterval = getTimeInterval(prefs);
			    }
			    
			    // Get current control "Users and Groups" filter
			    var aduserid = getPrefsPropertyValue(prefs, "aduser");
			    var adgroupid = getPrefsPropertyValue(prefs, "adgroup");
			    var adusername = getPrefsPropertyValue(prefs, "adusername");
			    var adgroupname = getPrefsPropertyValue(prefs, "adgroupname");
                
                // For no AD support
                if (adusername != "" && aduserid == "")
                    aduserid = adusername;
		
		        if (aduserid == "static") {
                    aduserid = "";
                    adusername = "";
                }
                if (adgroupid == "static") {
                    adgroupid = "";
                    adgroupname = "";
                }
                    
		        if (currentDDURL != "") 
                    window.open("/CardioLog/CLReport/ContextBasedReport.aspx?timeframe=" +timeframe+ "&timeInterval=" +timeInterval + "&startDate=" + startDate + "&endDate=" + endDate + "&templateId="+entry.id+"&url="+escape(currentDDURL)+"&uid="+escape(aduserid)+"&un="+escape(adusername)+"&gid="+escape(adgroupid)+"&gn="+escape(adgroupname));
                else if (currentDDUser != "") {
                    // support drill down by URL
                    if (element.entityId == element.document.EntityId) {
                        var url = escape(getPrefsPropertyValue(prefs, "entityurl").replace(/&amp;/g, "&"));
                        if (url != "") window.open("/CardioLog/CLReport/ContextBasedReport.aspx?timeframe=" +timeframe+ "&timeInterval=" +timeInterval + "&startDate=" + startDate + "&endDate=" + endDate + "&templateId="+entry.id+"&userName="+escape(currentDDUser)+"&url="+url);
                        else window.open("/CardioLog/CLReport/ContextBasedReport.aspx?timeframe=" +timeframe+ "&timeInterval=" +timeInterval + "&startDate=" + startDate + "&endDate=" + endDate + "&templateId="+entry.id+"&userName="+escape(currentDDUser)+"&entityId="+element.entityId);
                    } else
                        window.open("/CardioLog/CLReport/ContextBasedReport.aspx?timeframe=" +timeframe+ "&timeInterval=" +timeInterval + "&startDate=" + startDate + "&endDate=" + endDate + "&templateId="+entry.id+"&userName="+escape(currentDDUser)+"&entityId="+element.entityId);
                } else if (currentDDCategory != ""){
                    var categoryId = getCategoryId(prefs);
                    window.open("/CardioLog/CLReport/ContextBasedReport.aspx?timeframe=" +timeframe+ "&timeInterval=" +timeInterval + "&startDate=" + startDate + "&endDate=" + endDate + "&templateId="+entry.id+"&entityId="+element.entityId+"&categoryId="+categoryId+"&categoryValue="+escape(currentDDCategory)+"&uid="+escape(aduserid)+"&un="+escape(adusername)+"&gid="+escape(adgroupid)+"&gn="+escape(adgroupname));
                } else if (currentDDStatusCode != "") {
                    window.open("/CardioLog/CLReport/ContextBasedReport.aspx?templateId="+entry.id + "&crawlId=" + currentDDCrawlId + "&statusCode=" +currentDDStatusCode);
                }
            }
		}
		
		function drilldownDown() {
			// wrap the whole function in the next if?
			//if (insideCardiologEnvironment() && (!element.document.IsWebPart))
			var offsetHeight = this.offsetHeight;
			function clearMenu() {
				var foundSeperator = false;
				for (var i=element.document.ddMenu.entries.length-1;i>=0;i--) {
					if (element.document.ddMenu.entries[i].type == "separator") foundSeperator = true;
					else if (foundSeperator) element.document.ddMenu.entries.splice(i, 1);
				}
			}
			var anchor = (this.nextSibling.nextSibling) ? this : this.parentElement;
			function callback(templates) {
				for(var i = 0; i< templates.length; i++)
					templates[i].name = decodeURIComponent(templates[i].name);
				// Sort the templates.
				templates.sort(function (a, b) {
					var upA = a.name.toUpperCase();
					var upB = b.name.toUpperCase();
					return (upA < upB) ? -1 : (upA > upB) ? 1 : 0;
				});
		
				clearMenu();
		
				// We add the templates in reverse order, thus we need to start from the last one, so they appear sorted.
				for (var i=templates.length-1;i>=0;i--) 
				{
					templates[i].name = templates[i].name.replace(/&/g, '&amp;');
					element.document.ddMenu.addEntryBefore({id:templates[i].id, caption:templates[i].name+"&"}, true);// added & to hackfix ampersand display problem.
				}
				if (templates.length == 0) element.document.ddMenu.addEntryBefore({id:"noTemplates", caption:"<%=CardioLog.API.Localization.getText("$Could not find templates for this object$")%>"}, true);
				element.document.ddMenu.show(anchor, (templates.length == 0) ? null : doDrillDown, {x:anchor.offsetWidth, y:offsetHeight, right:true});
			}
			clearMenu();
			element.document.ddMenu.addEntryBefore({id:"pleaseWait", caption:"<%=CardioLog.API.Localization.getText("$Loading$")%>..."}, true);
			
			// Remove "Find in tree", "Show Diagnosis" in drill down
			element.document.ddMenu.removeEntry("sync");
			element.document.ddMenu.removeEntry("showDiagnosis");

			if (this.category) {
				currentDDURL = "";
				currentDDUser = "";
				currentDDCategory = (this.parentElement.category) ? this.parentElement.category : this.category;
				element.document.ddMenu.disableEntry("openPage");
				element.document.ddMenu.disableEntry("sync");
				element.document.ddMenu.disableEntry("showDiagnosis", true);
			} else if (this.statuscode) {
				currentDDStatusCode = (this.parentElement.statuscode) ? this.parentElement.statuscode : this.statuscode;
				currentDDCrawlId = getSEOCrawlId(prefs);
				element.document.ddMenu.disableEntry("openPage");
			} else if (typeof(this.url) == "undefined") {
				currentDDURL = "";
				currentDDCategory = "";
				currentDDUser = (this.parentElement.useraccountname) ? this.parentElement.useraccountname : this.user;
				element.document.ddMenu.disableEntry("openPage");
				element.document.ddMenu.disableEntry("sync");
				element.document.ddMenu.disableEntry("showDiagnosis", true);
			} else {
				currentDDUser = "";
				currentDDCategory = "";
				currentDDURL = this.url;
				element.document.ddMenu.enableEntry("openPage");
				if (element.document.isReport) {
					element.document.ddMenu.disableEntry("sync");
					element.document.ddMenu.disableEntry("showDiagnosis", true);
				} else {
					element.document.ddMenu.enableEntry("sync");
					element.document.ddMenu.enableEntry("showDiagnosis", true);
				}
			}
			
			element.document.ddMenu.show(anchor, null, {x:anchor.offsetWidth, y:this.offsetHeight, right:true});
			
			if (this.category) {
				var categoryId = getCategoryId(prefs);
				element.document.scheduler.retrieveTemplatesByCategory(categoryId, callback);
			} else if (typeof(this.url) == "undefined") {
				if (this.statuscode)
					element.document.scheduler.retrieveTemplatesForSEOStatusCode(this.statuscode, callback);
				else if (this.user)
					element.document.scheduler.retrieveTemplatesByUser(this.user, callback);
			} else {
				element.document.scheduler.retrieveTemplates(encodeURIComponent( this.url), callback);
			}
		}

        function drilldownOut() {
            this.src = this.src.replace(/HL\.gif/i, ".gif");
        }
		
        function drilldownOver() {
            this.src = this.src.replace(/\.gif/i, "HL.gif");
        }
		
		function drawResults(from) {
			if (document.all["pleaseWaitRow"]) {
				document.all["pleaseWaitRow"].removeNode(true);
			}

			for (var i=from;i<arr.length;i++) {
				tr = document.createElement("tr");
				if (element.enableSelection) {
					tr.selected = false;
					tr.onmouseover = RowOver;
					tr.onmouseout = RowOut;
					tr.className = "rowout";
					tr.onclick = RowClick;
					if (element.dblclickcallback) tr.ondblclick = RowDblClick;
				}
				else 
				{				
			        if (i%2 == 1) tr.style.background = "#e1e6ec";
			        else tr.style.background = "#ffffff";
				}

				for (var d in arr[i]) {
					// Remove dup_ string
					arr[i][d].text = arr[i][d].text.replace(/^.*?(?=http)/i, "");

					if (columnsArr[d.toLowerCase()] && columnsArr[d.toLowerCase()].type == "hidden") {
						tr[d.toLowerCase()] = arr[i][d].text;
						continue;
					}

					td = document.createElement("td");
					td.id = d.toLowerCase();
					td.noWrap = "true";
					td.className = "data";
					
						span = document.createElement("span");
						
						td.appendChild(span);
						if (!element.enableSelection && arr[i][d].text.match(/^http\:/)) {
							var a = document.createElement("a");
							a.ondblclick = valuedblclick;
							a.href = arr[i][d].text;
							a.innerText = arr[i][d].text+" ";
							a.target = "_blank";
							a.className = "reglink";
							span.appendChild(a);
							a = null;

                            td.url = arr[i][d].text;
                            if (columnsArr[d.toLowerCase()] && columnsArr[d.toLowerCase()].type == "SEOPage") { 
                                // no drill down for SEO pages
                            } else {
                                td.onclick = drilldownDown;
                                td.onmouseover = showDrillDown;
                                td.onmouseout = hideDrillDown;
                            }
						} else if (!element.enableSelection && columnsArr[d.toLowerCase()] && columnsArr[d.toLowerCase()].type == "SPPage" && (arr[i]["URL"] || arr[i]["Url"])) { 
							var url = "";
							if (arr[i]["URL"] != null)
								url = arr[i]["URL"].text;
							else if (arr[i]["Url"] != null)
								url = arr[i]["Url"].text;
                            var a = document.createElement("a");
							a.ondblclick = valuedblclick;
							a.href = "javascript:";
							if (arr[i][d].text.match(/[א-ת]/)) a.dir = "rtl";
							a.innerText = arr[i][d].text+" ";
							// Remove dup_ string in links to the actual page
							a.title = url.replace(/^.*?(?=http)/i, "");
							a.className = "reglink";
							a.onclick = SPSPageClick;
//							a.oncontextmenu = SPSPageContextClick;
							span.appendChild(a);
							a = null;
                            
                            td.onclick = drilldownDown;
                            td.url = url;
                            td.onmouseover = showDrillDown;
                            td.onmouseout = hideDrillDown;
						} else {
							span.innerText = arr[i][d].text+" ";
							span.title = arr[i][d].text+"\n<%=CardioLog.API.Localization.getText("$Double click to copy value$")%>";
							span.ondblclick = valuedblclick;
							if (columnsArr[d.toLowerCase()] && columnsArr[d.toLowerCase()].type=="user") {
                                td.onclick = drilldownDown;
                                td.user = arr[i][d].text;
                                td.onmouseover = showDrillDown;
                                td.onmouseout = hideDrillDown;
                            } else if (columnsArr[d.toLowerCase()] && columnsArr[d.toLowerCase()].type == "category") { // drill down by category values
                                td.onclick = drilldownDown;
                                td.category = arr[i][d].text;
                                td.onmouseover = showDrillDown;
                                td.onmouseout = hideDrillDown; 
    						} else if (columnsArr[d.toLowerCase()] && columnsArr[d.toLowerCase()].type == "SEOStatusCode") { // drill down on seo status code
                                td.onclick = drilldownDown;
                                td.statuscode = arr[i][d].text;
                                td.onmouseover = showDrillDown;
                                td.onmouseout = hideDrillDown; 
                            }
						}
						
					tr.appendChild(td);
					
					td = document.createElement("td");
					td.innerText = " ";
					td.className = "data";
					tr.appendChild(td);
				}
				tbody.appendChild(tr);
				if (i == from) {
					//tr.scrollIntoView(true);
				}

				for (var o=0;o<vobject.length;o++) {
					// Milen: this row caused error so i added "tr.children(o*2)" to the condition.
					//Now a bug has presented itself in the table when sorting by user(asc) and loading all records.
					if (tr.children(o*2) && tr.children(o*2).children(0).offsetWidth > vobject[o].maxSize) vobject[o].maxSize = tr.children(o*2).children(0).offsetWidth;
				}
			}

			if (element.to < element.total) {
				tr = document.createElement("tr");
				tr.id = "pleaseWaitRow";
				td = document.createElement("td");
				td.colSpan = vobject.length*2;
				td.height = "500px";
				td.vAlign = "top";
				td.innerText = "<%=CardioLog.API.Localization.getText("$Loading more results, Please wait$")%>...";
				tr.appendChild(td);
				tbody.appendChild(tr);
				
				// check if to load next chunk of data 
				element.loading = false;
				loadData();
			}
		}
		
		function showDrillDown() {
            this.className += this.className+" drilldown";
        }
        function hideDrillDown() {
            this.className = "data";
        }
		function loadData() {
			if (element.loading) return;

			if (document.all["pleaseWaitRow"] && document.all["pleaseWaitRow"].offsetTop < document.all["resultsDiv"].scrollTop+document.all["resultsDiv"].clientHeight) {
				element.loading = true;
				var numOfRowsToGet = Math.round(parseInt(document.all["resultsDiv"].clientHeight, 10)/20);
				var scheduler = (element.scheduler) ? element.scheduler : element.document.scheduler

				// prefs - clpage preferences(not updated on 'save' from preferences page)
				// element.tempPrefs = false at first - preferences page preferences
				if(prefs == "<prefs />")// Check if we are in the report page. If this is true, prefs are not set and we are in the preferences page.
					scheduler.getDataOnce(cid, element.tempPrefs, appendData, {from:eval(element.to+1), to:eval(element.to+1+(numOfRowsToGet*3)), sort:element.sortColumn, direction:element.direction});
				else
					scheduler.getDataOnce(cid, prefs, appendData, {from:eval(element.to+1), to:eval(element.to+1+(numOfRowsToGet*3)), sort:element.sortColumn, direction:element.direction});
			}
		}
		
		element.sortColumn = "";
		element.direction = -1;
		element.tempPrefs = false;
		
		function sortTable(sortByClient, sortBy, direction) {
			var sortColumn = "";
			var sortType = "";
			
			// Check if we have loaded all records for the selected ammount
			if (element.to == element.total) {
				// If we have all records, sort the table without querying the server
				//sortColumn = sortByClient.replace(/^[ ]*/, "").replace(/[ ]*$/, "");
				sortByClient = sortByClient.replace(/^[ ]*/, "").replace(/[ ]*$/, "");
				sortColumn = sortBy.replace(/^[ ]*/, "").replace(/[ ]*$/, "").toUpperCase();
				sortType = "";
				
				for (var i=0;i<columns.length;i++) {
					//if (columns[i].text == sortColumn) {
					if (columns[i].text == sortByClient) {
						sortType = columns[i].getAttribute("type");
					}
				}
				
				try{
					function compareStrings(a, b) {
						if (a[sortByClient].value.toUpperCase() > b[sortByClient].value.toUpperCase()) return 1*direction;
						else return -1*direction;
					}
				
					function compare(a, b) {
						if (parseInt(a[sortByClient].value,10) > parseInt(b[sortByClient].value,10)) return 1*direction;
						else return -1*direction;
					}
				}
				catch(e){
				}

				if (sortType == "number") arr = arr.sort(compare);
				else arr = arr.sort(compareStrings);
				drawTable();
			} else {
				// If we don't have all records in the table, prepare a query to the server with the preferences to get the needed preferences, sorted on the server.
				var scheduler = (element.scheduler) ? element.scheduler : element.document.scheduler
				
				sortColumn = sortBy.replace(/^[ ]*/, "").replace(/[ ]*$/, "");
				element.sortColumn = sortColumn;
				element.direction = direction;

				// prefs - clpage preferences(not updated on 'save' from preferences page)
				// element.tempPrefs = false at first - preferences page preferences
				if(prefs == "<prefs />")// Check if we are in the report page. If this is true, prefs are not set and we are in the preferences page.
					scheduler.getDataOnce(cid, element.tempPrefs, refresh, {from:0, to:element.to, sort:sortColumn, direction:direction});
				else
					scheduler.getDataOnce(cid, prefs, refresh, {from:0, to:element.to, sort:sortColumn, direction:direction});
//				scheduler.callSpecificViewer(cid, {from:0, to:element.to, sort:sortColumn, direction:direction});
			}
		}
		
		var pos = {x:0, y:0}
		function findPosition(obj) {
			pos.x += parseInt(obj.offsetLeft, 10);
			pos.y += parseInt(obj.offsetTop, 10);
			if (obj.tagName != "BODY") findPosition(obj.offsetParent);
		}

		var resizing = false;
		document.onselectstart = function() {
			event.returnValue = false;
			event.cancelBubble = true;
		}
		document.onmousemove = function() {
			if (resizing) {
				var e = {x:event.x};
				window.setTimeout(function() {
					var width = e.x-((resizing !== false) ? resizing.x : 0);
					if (width < 20) width = 20;
					document.all["resizeDiv"].style.width = width;
				}, 1);
			}
		}
		document.onmouseup = function() {
			if (resizing) {
				handleResize(parseInt(document.all["resizeDiv"].style.width, 10), resizing.col);
			}
		}
		
		function handleResize(newWidth, column) {
			var oldWidth = parseInt(document.all["thead"][0].children(0).children(column*2).offsetWidth, 10);
			var theads = document.all["thead"];
			for (var i=0;i<2;i++) 
				document.all["thead"][i].children(0).children(column*2).width = newWidth;
			resizing = false;
			document.all["resizeDiv"].style.display = "none";
		}
		
		function getTitle() {
			return element.parent.title+" - "+element.ctitle;
		}
		
		function valuedblclick() {
			event.cancelBubble = true;
			document.getElementById("texttocopy").value = this.innerText;
			var ctc = document.getElementById("texttocopy").createTextRange();
			ctc.execCommand("Copy");
			this.style.color = "white";
			this.style.background = "highlight";
			var t = this;
			window.setTimeout(function() {
				t.style.color = "";
				t.style.background = "";
			}, 500);
			return false;
		}

		function syncHeader(obj) {
			resultsHeaderDiv.scrollLeft = obj.scrollLeft;
		}
	</script>
<script>
	function getValue(g, c, b) { var d = new RegExp("^[^$]*<" + c + ">(.*?)</" + c + ">[^$]*$", "i"); var f = g.replace(d, "$1"); if (f == g || f.replace(/ /g, "") == "") { return b } else { return f } } function getValueFromXML(d, c, b) { if (xmlStringObj.selectSingleNode(".//" + c)) { return xmlStringObj.selectSingleNode(".//" + c).text } else { return b } } try { document.Ajax = (parent && parent.document && parent.document.Ajax) ? parent.document.Ajax : false; document.Status = (parent && parent.document && parent.document.Status) ? parent.document.Status : { print: function () { }, clear: function () { } } } catch (e) { } function escapeToHebrew(d) { if (!d.match(/[?-?]/)) { return d } var c = ""; for (var b = 0; b < d.length; b++) { if (d.substring(b, b + 1).match(/[?-?]/)) { var f = parseInt(d.charCodeAt(b), 10) - 1488 + parseInt(224, 10); c += "%" + f.toString(16).toUpperCase() } else { c += d.substring(b, b + 1) } } return c } function insideCardiologEnvironment() { try { var c = top.location.href; return true } catch (b) { return false } } function getCardioLogParentWindow() { var c = self; try { while (c.location.href != "") { a = c.parent.location.href; if (c == c.parent) { return c } c = c.parent } return c } catch (b) { return c } } function toggleHelp(d) { var b = toggleHelpSection(d); if (document.IsReport) { return } var c = document.scheduler.updatePreferences(d._id, [((d.id.match(/preferences/i)) ? "showpreferences" : "showhelp")], [!b]); document.scheduler.setPreferences(d._id, c, false, true) } function toggleMeterHelp(d) { var b = toggleHelpSection(d); if (document.IsReport) { return } var c = document.scheduler.updatePreferences(d._id, [((d.id.match(/preferences/i)) ? "showpreferences" : "showhelp")], [!b]); document.scheduler.setPreferences(d._id, c, false, true, true) } function toggleHelpSection(d, b) { var c; if (b) { c = (b == "true") ? false : true } else { c = (d.className.match(/Open$/)) ? true : false } d.nextSibling.style.display = c ? "none" : ""; d.className = "boxHelpSection" + (c ? "Close" : "Open"); return c } function openHelpSection(f, d) { if (document.IsReport) { var c = findBox(d ? -1 : f); if (c) { c.toggleHelpIcon("true", "true", f, b) } } else { var b = document.scheduler.updatePreferences(f, ["showhelp", "showpreferences"], [true, true]); document.scheduler.setPreferences(f, b, false, true, d) } } function findBox(d) { var c = document.all.cardioLogBox; if (c && c.length) { for (var b = 0; b < c.length; b++) { if (c[b]._id == d) { return c[b] } } } else { if (c && c._id == d) { return c } } } function closeHelpSection(f, d) { if (document.IsReport) { var c = findBox(d ? -1 : f); if (c) { c.toggleHelpIcon("false", "false", f, b) } } else { var b = document.scheduler.updatePreferences(f, ["showhelp", "showpreferences"], [false, false]); document.scheduler.setPreferences(f + "", b, false, true, d) } } function openPreferences(c, b) { event.cancelBubble = true; document.scheduler.openPreferences(c, b); return false };
</script>
</head>
<body style="border:0px;">
	<table id="mainTable" border="0" cellpadding="0" cellspacing="0" height="100%" width="95%" style="table-layout:fixed;">
		<tr>
			<td>
				<div id="resultsHeaderDiv" style="overflow-y:hidden; overflow-x:hidden; width:100%;">
					<table id="headTable" cellpadding="3" cellspacing="0" border="0" width="100%" style="table-layout:fixed;">
						<tbody id="thead"></tbody>
					</table>
				</div>
			</td>
		</tr>	
		<tr>
		    <td height="100%" width="100%">
				<div class="scrollTable" id="resultsDiv" onscroll="syncHeader(this); loadData();" onresize="loadData();" style="overflow-y:auto; overflow-x:auto; width:100%; height:100%;">
					<table id="bodyTable" cellpadding="3" cellspacing="0" border="0" style="table-layout:fixed;">
						<thead id="thead" style="display:none;"></thead>
						<tbody id="tbody"></tbody>
						<tfoot><tr><td height="100%"></td></tr></tfoot>
					</table>
				</div>
			</td>
		</tr>	
		<tr>
			<td>
				<div style="overflow-y:hidden; overflow-x:hidden; width:100%;" id="footerDiv">
					<table id="footTable" cellpadding="3" cellspacing="0" border="0" width="100%" style="table-layout:fixed;">
						<thead id="thead" style="display:none;"></thead>
						<tbody id="tfoot"></tbody>
					</table>
				</div>
			</td>
		</tr>
	</table>
	
	<div id="resizeDiv" style="border:1px solid gray; background:gray; filter:alpha(opacity=50); position:absolute; top:0; left:0; display:none;"></div>
	<textarea id="texttocopy" style="display:none;"></textarea>
</body>
</html>