﻿<%@ OutputCache Duration="864000" VaryByHeader="Host" VaryByParam="none" Location="any"%>
<%@ Page language="C#" %>
<%
	Response.ContentType = "text/x-component";
	bool realTime;
	try
	{
        realTime = CardioLog.API.ProductLicense.ProductFeatures.IsValidRealTimeReports;
	}
	catch
	{
	    realTime = false;
	}
%>
<html xmlns:v="urn:schemas-microsoft-com:vml" xmlns:CARDIOLOG>
<head>
	<LINK rel="stylesheet" type="text/css" href="../../Styles/general.css"></LINK>
	<meta http-equiv="content-type" content="text/html; charset=utf-8">
	<PUBLIC:COMPONENT tagName=PREFERENCES>
		<PUBLIC:ATTACH event="oncontentready" onevent="init()"/>
		<PUBLIC:METHOD name="setPreferences"/>
		<PUBLIC:METHOD name="getPreferences"/>
		<PUBLIC:METHOD name="setType"/>
		<PUBLIC:METHOD name="getChartType"/>
		<PUBLIC:METHOD name="getTimeFrame"/>
		<PUBLIC:METHOD name="getEntityId"/>
		<PUBLIC:METHOD name="setMandatoryContext"/>
		<PUBLIC:METHOD name="setDirtyFlag"/>	
		<PUBLIC:METHOD name="toggleHelp"/>
		<PUBLIC:METHOD name="setAbout"/>
		
		<PUBLIC:METHOD name="attachExternalField"/>
	</PUBLIC:COMPONENT>

	<script language="jscript" src="/CardioLog/Controls/Preference/PreferencesCommon.aspx"></script>

	<script language="JScript">
		element.mandatoryContext = false;

		var Constants = {currentPage:"current page", unknownPage:"unknown page"};
		
		element.type = "chart";
		
		function setDirtyFlag() {
			var inputs = document.getElementsByTagName("input");
			for (var i=0;i<inputs.length;i++) {
				inputs[i].attachEvent("onpropertychange", function() {
					if (event.propertyName == "value" || event.propertyName == "checked") {
						element.document.dirtyFlag = true;
					}
				});
				inputs[i].attachEvent("onkeydown", function() {
					event.srcElement.orgValue = event.srcElement.value;
				});
				inputs[i].attachEvent("onkeyup", function() {
					if (event.srcElement.value != event.srcElement.orgValue) element.document.dirtyFlag = true;
				});
			}
			
			var selects = document.getElementsByTagName("select");
			for (var i=0;i<selects.length;i++) {
				selects[i].attachEvent("onchange", function() {
					element.document.dirtyFlag = true;
				});
			}
		}

		function setType(type) {
			element.type = type;
			document.all["aboutThisSpan"].innerText = (type == "report") ? "table" : "meter";
		}
		
		var DEFAULT_PREFERENCES = "<prefs>"+
										"<timeFrame>36000000000</timeFrame>"+
										"<timeInterval>36000000000</timeInterval>"+
									"</prefs>";

		var _chartType;
		
		var imagesPath;
		element.params = new Array();
		
		element.xmlObj = new ActiveXObject("Msxml.DOMDocument");
		element.xmlObj.async = false;
	
		var charts = new Array();
		charts[charts.length] = {name:"Columns 2D", value:"FC_2_3_MSColumn2D"};
		charts[charts.length] = {name:"Columns 3D", value:"FC_2_3_MSColumn3D"};
		charts[charts.length] = {name:"Bars 2D", value:"FC_2_3_MSBar2D"};
		charts[charts.length] = {name:"Area 2D", value:"FC_2_3_MSArea2D"};
		charts[charts.length] = {name:"Lines 2D", value:"FC_2_3_MSLine_2"};
		charts[charts.length] = {name:"Stacked Area", value:"FC_2_3_StckdArea"};
		charts[charts.length] = {name:"Stacked Bar 2D", value:"FC_2_3_StckdBar2D"};
		charts[charts.length] = {name:"Stacked Column 2D", value:"FC_2_3_StckdColumn2D"};
		charts[charts.length] = {name:"Stacked Column 3D", value:"FC_2_3_StckdColumn3D"};
		
		function getChartType() {
			return _chartType;
		}
		
		function showChartTypeSelect(value) {
			document.all["chartTypeSelect"].style.display = "";
			for (var i=0;i<document.all["chartTypeTd"].length;i++) document.all["chartTypeTd"][i].style.display = "";
			for (var i=0;i<charts.length;i++) {
				var option = document.createElement("option");
				option.value = charts[i].value;
				option.innerText = charts[i].name;
				if (charts[i].value == value) option.selected = true;
				document.all["chartTypeSelect"].appendChild(option);
				option = null;
			}
		}
		
		function init() {
			defaults.viewLink = document;
			defaults.viewInheritStyle = false;

			stylesPath = (element.stylesPath) ? element.stylesPath : "";
			imagesPath = (element.imagesPath) ? element.imagesPath : "";

			document.createStyleSheet(stylesPath+'general.css');

			for (var i=0;i<element.children.length;i++) {
				element.params[element.children(i).tagName] = element.children(i).innerHTML;
			}
			
			setPreferences((element.params["Prefs"]) ? element.params["Prefs"] : "<prefs />");

		}

		var externalFields = new Array();
		function attachExternalField(field, defaultValue) {
			field.defaultValue = defaultValue;
			externalFields[field.id] = field;
		}
		
		function getPreferences() {
			var prefsString = "<PREFS>"+
							"<SHOWHELP>"+document.all["showHelp"].checked+"</SHOWHELP>"+
							"<SHOWPREFERENCES>"+document.all["showPreferences"].checked+"</SHOWPREFERENCES>";

            var timeFrameValue = getValue("TIMEFRAME", false);
            if (timeFrameValue == "static") {
                prefsString += "<TIMEFRAME>static</TIMEFRAME>";
            } else if (timeFrameValue) {
				var timeFrameOption = document.all["timeFrame"].options[document.all["timeFrame"].selectedIndex];
				prefsString += "<TIMEFRAME>"+document.all["timeFrame"].options[document.all["timeFrame"].selectedIndex].value+"</TIMEFRAME>";
				if (timeFrameOption.value == "0") {
					prefsString += "<TIMEFRAME_START>"+timeFrameOption.timeFrameStart+"</TIMEFRAME_START>"+
												"<TIMEFRAME_END>"+timeFrameOption.timeFrameEnd+"</TIMEFRAME_END>"+
												"<TIMEFRAME_TITLE>"+timeFrameOption.innerText+"</TIMEFRAME_TITLE>";
					prefsString += "<TIMEINTERVAL>1077760000000000</TIMEINTERVAL>";
				} else {
					//if (element.type == "meter") prefsString += "<TIMEINTERVAL>1077760000000000</TIMEINTERVAL>";
					//else prefsString += "<TIMEINTERVAL>"+Math.abs(document.all["timeFrame"].options[document.all["timeFrame"].selectedIndex].value)+"</TIMEINTERVAL>";
					prefsString += "<TIMEINTERVAL>"+Math.abs(document.all["timeFrame"].options[document.all["timeFrame"].selectedIndex].value)+"</TIMEINTERVAL>";
				}
			}
			switch (element.type) {
				case "chart":
					prefsString += getChartPreferences();
					break;
				case "meter":
					prefsString += getMeterPreferences();
					break;
				case "report":
					break;
			}

			var genprefs = document.getElementsByName("genprefs");
			for (var i=0;i<genprefs.length;i++) {
				prefsString += "<"+genprefs[i].id.toUpperCase()+">"+genprefs[i].value+"</"+genprefs[i].id.toUpperCase()+">";
			}
			
			for (var i in externalFields) {
				prefsString += "<"+i+">"+externalFields[i].value+"</"+i+">";
			}

			if (document.all["entityType"]) prefsString += "<entityType>"+document.all["entityType"].value+"</entityType>";
			if (document.all["categoryId"]) prefsString += "<categoryId>"+document.all["categoryId"].value+"</categoryId>";

			if (document.all["chooseEntityUrl"].style.display == "") {
				prefsString += "<entityUrl>"+document.all["entityUrl"].value+"</entityUrl>";
			}

			if (document.all["chooseEntity"].style.display == "") {
				if (document.all["entityId"].value != "") {
					prefsString += "<entityId>"+getSource().value+"</entityId>"+
												"<entityName>"+getSource().innerText+"</entityName>"+
												"<entityTree>"+document.all["entityTree"].value+"</entityTree>";
				}
			} else {
				prefsString += "<entityId>static</entityId>";
			}
			
			prefsString += "<chartType>static</chartType>";

			// handle AD grouping
			if (document.all["groupSelectInput"].style.display == "") {
				var groupSelectValue = document.all["groupSelect"].options[document.all["groupSelect"].selectedIndex].value;
				var groupSelectText = document.all["groupSelect"].options[document.all["groupSelect"].selectedIndex].innerText;
				var groupIdsArr = groupSelectValue.split(',');
				var groupNamesArr = groupSelectText.split(',');
				var userIds = "";
				var groupIds = "";
				var userNames = "";
				var groupNames = "";
				for(var i=0;i<groupIdsArr.length;i++) {
					if ( groupIdsArr[i] != "" ) {
						var objectIdsArr = groupIdsArr[i].split(';');
						if ( objectIdsArr[1] == "user" ) {
							userIds += objectIdsArr[0] + ",";
							userNames += groupNamesArr[i] + ",";
						} else {
							groupIds += objectIdsArr[0] + ",";
							groupNames += groupNamesArr[i] + ",";
						}
					}
				}
				userIds = userIds.replace(/,$/, "");
				groupIds = groupIds.replace(/,$/, "");
				userNames = userNames.replace(/,$/, "");
				groupNames = groupNames.replace(/,$/, "");
				
				if ( userIds != "" ) {
					prefsString += "<ADUSER>"+userIds+"</ADUSER>";
					prefsString += "<ADUSERNAME>"+userNames+"</ADUSERNAME>";
				}
				if ( groupIds != "" ) { 
					prefsString += "<ADGROUP>"+groupIds+"</ADGROUP>";
					prefsString += "<ADGROUPNAME>"+groupNames+"</ADGROUPNAME>";
				}
				else prefsString += "<ADGROUP></ADGROUP><ADGROUPNAME></ADGROUPNAME>";
			} else if (preferences.adgroup == "static") prefsString += "<ADGROUP>static</ADGROUP>";
			else prefsString += "<ADGROUP></ADGROUP><ADGROUPNAME></ADGROUPNAME>"
			
				
			// handle categories
			if (preferences.categorySupport == "static") {
				prefsString += "<CATEGORYSUPPORT>static</CATEGORYSUPPORT>";
			} else {
				if (categories.length > 0) {
					prefsString += "<CATEGORIES>";
					for (var i=0;i<categories.length;i++) {
						var cid = categories[i].getAttribute("id");
						if (document.all["categorySelect"+cid].selectedIndex > 0)
						    prefsString += "<CATEGORY id='"+cid+"' value='"+document.all["categorySelect"+cid].options[document.all["categorySelect"+cid].selectedIndex].value+"'>"+document.all["categorySelect"+cid].options[document.all["categorySelect"+cid].selectedIndex].text.replace(/\&(?!amp;)/g,"&amp;")+"</CATEGORY>";
					}
					prefsString += "</CATEGORIES>";
				}
			}
			
			if (preferences.parameters) {
				for (var i=0;i<preferences.parameters.length;i++) {
					var field = new Field(preferences.parameters[i]);
					var currentValue = "";
					switch (field.type) {
						case "checkbox":
							currentValue = (document.getElementById(field.name).checked) ? 1 : 0;
							break;
						case "select":
							currentValue = document.getElementById(field.name).options[document.getElementById(field.name).selectedIndex].value;
							break;
						default:
							currentValue = document.getElementById(field.name).value;
							break;
					}
					prefsString += field.SetValue(currentValue);
				}
			}
			
			// handle multiple selection
			if (!document.multipleSelection) {
				prefsString += "<MULTIPLESELECTION>false</MULTIPLESELECTION>";
			}

            // handle custom columns
            if (document.all["columnsSelect"]){
                prefsString += "<CUSTOMCOLUMNS>";
                for (i=0;i<document.all["columnsSelect"].options.length;i++) {
                    if (document.all["columnsSelect"].options[i].selected) {
                        prefsString += "<CUSTOMCOLUMN id=\""+document.all["columnsSelect"].options[i].value+"\" title=\""+document.all["columnsSelect"].options[i].text+"\" type=\"string\" width=\"80\"/>";
                    }
                }
                prefsString += "</CUSTOMCOLUMNS>";
            }
           
			prefsString += "</PREFS>";
			//alert(prefsString);
			return prefsString;
		}

		function getMeterPreferences() {
			var prefsString = "<MINVALUE>"+document.all["minValue"].value+"</MINVALUE>"+
												"<MAXVALUE>"+document.all["maxValue"].value+"</MAXVALUE>"+
												"<UNDERSHOOT>"+document.all["undershoot"].value+"</UNDERSHOOT>"+
												"<OVERSHOOT>"+document.all["overshoot"].value+"</OVERSHOOT>";
			return prefsString;
		}
		
		function getChartPreferences() {
			var prefsString = "";
			if (rules && rules.length > 0) {
				prefsString += "<RULES>";
				for (var i=0;i<rules.length;i++) {
					var ruleId = rules[i].getAttribute("id");
					prefsString += "<RULE id='"+ruleId+"' "+
													"status='"+((document.all["__ruleStatus"+ruleId].checked) ? "on" : "off")+"' "+
													"title='"+rules[i].getAttribute("title")+"'";
					
					if (document.all["__ruleDual"+ruleId])
						prefsString += " dual='true'";
						
					if (document.all["__rulePeriod"+ruleId]) 
						prefsString += " period='"+document.all["__rulePeriod"+ruleId].value+"'/>";
					else
						prefsString += "/>";
				}
				prefsString += "</RULES>";
			}
			return prefsString;
		}		

		function setPreferences(controlPrefs) {
			prefs = controlPrefs;
			element.xmlObj.loadXML(prefs.replace(/\&(?!amp;)/g,"&amp;"));
			if (element.xmlObj.parseError.errorCode != 0) {
				element.xmlObj.loadXML(DEFAULT_PREFERENCES);
			}
			
			element.xml = element.xmlObj.xml;
			
			if (prefs == "<prefs />") return;
			drawPrefernces();
		}
		
		var rules;
		
		var preferences = new Array();
		
		function drawPrefernces() {
			var showHelp = getValue("SHOWHELP", false);
			var showPreferences = getValue("SHOWPREFERENCES", false);

			document.all["showHelp"].checked = (showHelp == "true") ? true : false;
			document.all["showPreferences"].checked = (showPreferences == "true") ? true : false;

			var timeFrame = getValue("TIMEFRAME", "36000000000");

			if (timeFrame == "static") {
                document.getElementById("chooseDateRange").style.display = "none";
            } else if (timeFrame == "0") {
				initPeriods(false, addCustomizedOption(getValue("TIMEINTERVAL", "36000000000"), getValue("TIMEFRAME_START", "20050101000000"), getValue("TIMEFRAME_END", "20050101235959"), getValue("TIMEFRAME_TITLE", "01/01/2005-01/01/2005")));
			} else {
				initPeriods(timeFrame);
			}
			
			var minFail = getValue("MINFAIL", false);
			var maxFail = getValue("MAXFAIL", false);

			var reportType = getValue("REPORTTYPE", false);
			
			var columns = getValue("COLUMNS", false);
		
			var maxRows = getValue("MAXROWS", false);
			var minCount = getValue("MINCOUNT", false);
			var maxCount = getValue("MAXCOUNT", false);
			
			var entityType = getValue("ENTITYTYPE", false);
			var categoryId = getValue("CATEGORYID", false);
			
			var entityId = getValue("ENTITYID", "");
			var entityTree = getValue("ENTITYTREE", "1");
			var entityUrl = getValue("ENTITYURL", "static");
			var multipleSelection = getValue("MULTIPLESELECTION", "true");
			
			var chartType = getValue("CHARTTYPE", "");

			var type = getValue("TYPE", "FC_2_3_Column2D");
			
			var customColumns = getValuesFromXML("CUSTOMCOLUMNS//CUSTOMCOLUMN");
			
			preferences.adgroup = getValue("ADGROUP", false);
			preferences.adgroupname = getValue("ADGROUPNAME", false);
			preferences.aduser = getValue("ADUSER", false);
			preferences.adusername = getValue("ADUSERNAME", false);

			preferences.categories = getValuesFromXML("CATEGORIES//CATEGORY");
			preferences.categorySupport = getValue("CATEGORYSUPPORT", false);

			if (minFail || maxFail) {
				showSection("advancedSectionTR");
				var tr, td, input;
				tr = document.createElement("tr");
				document.all["preferencesBody"].appendChild(tr);
					td = document.createElement("td");
					td.className = "largeTextB";
					td.innerText = "<%=CardioLog.API.Localization.getText("$Min Failure$")%>:";
					tr.appendChild(td);
					td = document.createElement("td");
						input = document.createElement("<input type='text' class='inputText' name='genprefs' id='minFail'>");
						input.style.width = "50px";
						input.className = "largeInputText";
						input.value = (minFail) ? minFail : 0;
						td.appendChild(input);
						input = null;
					tr.appendChild(td);
				
				tr = document.createElement("tr");
				document.all["preferencesBody"].appendChild(tr);
					td = document.createElement("td");
					td.innerText = "<%=CardioLog.API.Localization.getText("$Max Failure$")%>:";
					td.className = "largeTextB";
					tr.appendChild(td);
					td = document.createElement("td");
						input = document.createElement("<input type='text' class='inputText' name='genprefs' id='maxFail'>");
						input.style.width = "50px";
						input.className = "largeInputText";
						input.value = (maxFail) ? maxFail : 0;
						td.appendChild(input);
						input = null;
					tr.appendChild(td);
				td = null;
				tr = null;
			}

			if (maxRows) {
				showSection("advancedSectionTR");
				var tr, td, input;
				tr = document.createElement("tr");
				document.all["preferencesBody"].appendChild(tr);
					td = document.createElement("td");
					td.innerText = "<%=CardioLog.API.Localization.getText("$Number of Results$")%>:";
					td.className = "largeTextB";
					tr.appendChild(td);
					td = document.createElement("td");
						td.appendChild(createField("maxRows", maxRows));
					tr.appendChild(td);
				td = null;
				tr = null;				
			}
			if (minCount) {
				showSection("advancedSectionTR");
				var tr, td, input;
				tr = document.createElement("tr");
				document.all["preferencesBody"].appendChild(tr);
					td = document.createElement("td");
					td.innerText = "<%=CardioLog.API.Localization.getText("$Minimum Results Count$")%>:";
					td.className = "largeTextB";
					tr.appendChild(td);
					td = document.createElement("td");
						td.appendChild(createField("minCount", minCount));
					tr.appendChild(td);
				td = null;
				tr = null;				
			}
			
			if (maxCount) {
				showSection("advancedSectionTR");
				var tr, td, input;
				tr = document.createElement("tr");
				document.all["preferencesBody"].appendChild(tr);
					td = document.createElement("td");
					td.innerText = "<%=CardioLog.API.Localization.getText("$Maximum Results Count$")%>:";
					td.className = "largeTextB";
					tr.appendChild(td);
					td = document.createElement("td");
						td.appendChild(createField("maxCount", maxCount));
					tr.appendChild(td);
				td = null;
				tr = null;				
			}
			
			if (reportType) createHiddenField("reportType", reportType);
			
			if (columns) createHiddenField("columns", columns);
			
			if (entityType) {
				showSection("advancedSectionTR");
				var tr, td, input;
				tr = document.createElement("tr");
				tr.style.display = "none";
				
				document.all["preferencesBody"].appendChild(tr);
					td = document.createElement("td");
					td.innerText = "Entity Type:";
					td.className = "largeTextB";
					tr.appendChild(td);
					td = document.createElement("td");
						input = document.createElement("<input type='text' id='entityType'>");
						input.value = entityType;
						td.appendChild(input);
/*						
						select = document.createElement("<select id='entityType'>");
						select.className = "largeInputSelect";
							select.appendChild(createOption("0", "Area", (entityType == 0)));
							select.appendChild(createOption("1", "Site", (entityType == 1)));
							select.appendChild(createOption("2", "List", (entityType == 2)));
							select.appendChild(createOption("6", "List Item", (entityType == 6)));
						td.appendChild(select);
*/
					tr.appendChild(td);
				td = null;
				tr = null;				
			}
			
			if (categoryId) {
				showSection("advancedSectionTR");
				var tr, td, input;
				tr = document.createElement("tr");
				tr.style.display = "none";
				
				document.all["preferencesBody"].appendChild(tr);
					td = document.createElement("td");
					td.innerText = "Category:";
					td.className = "largeTextB";
					tr.appendChild(td);
					td = document.createElement("td");
						input = document.createElement("<input id='categoryId'>");
						input.value = categoryId;
						td.appendChild(input);
					tr.appendChild(td);
				td = null;
				tr = null;				
			}
			/* Draw categories selection box */
			//TODO: hide/show categories selection box not based on reportType?
            if (reportType == "126" || reportType == "300" || reportType == "302" || reportType == "271") { // Unique Users Table || Unique Idea Submitters || Unique Idea Voters || Video Viewers
                showSection("categoriesSectionTR");
                try {
			        function callback(status) {
			           var tr, td, select, option;
				        categories = status.ResponseXml.selectNodes(".//Category");
				        tr = document.createElement("tr");
		                
		                td = document.createElement("td");
		                td.colSpan = 2;
		                td.className = "largeTextB";
		                td.innerText = "<%=CardioLog.API.Localization.getText("$Select User Categories$")%>:";
		                td.appendChild(document.createElement("br"));
                		
                		
		                select = document.createElement("select");
		                select.id = "columnsSelect";
		                select.className = "largeInputSelect";
		                select.style.width = "180px";
		                select.multiple = true;
		                td.appendChild(select);
                		
		                for (var i=0;i<categories.length;i++) {
		                    option = document.createElement("option");
		                    option.value = categories[i].getAttribute("id");
		                    option.innerText = categories[i].text;
		                    
		                    for (var j=0;j<customColumns.length;j++){
		                        if (option.innerText == customColumns[j].getAttribute("title")) {
		                            option.selected = true;
		                        }
		                    }
		                    
		                    select.appendChild(option);
		                    option = null;
		                }
		                tr.appendChild(td);

		                document.all["categoriesBody"].appendChild(tr);
		                select = null;
		                td = null;
		                tr = null;
			        }
			        dialogArguments.opener.Ajax.Request("GET", "data/categories.aspx", "action=getCategories", true, false, callback);
		        } catch (e) {   
		        }
            }


			
			if (entityUrl != "static") {
				document.all["entityUrl"].innerText = entityUrl;
			} else document.all["chooseEntityUrl"].style.display = "none";

			if (entityId != "static") {
				var entityName = getValue("ENTITYNAME", Constants.currentPage);
				
				addSource(entityId, entityName);

				document.all["entityId"].innerText = entityId;
				document.all["entityTree"].value = entityTree;
			} else document.all["chooseEntity"].style.display = "none";
			
			document.multipleSelection = eval(multipleSelection);

			if (element.showChartType) {
				_chartType = type;
				if (chartType != "static") {
					showChartTypeSelect(type);
				}
			}
						
			switch (element.type) {
				case "chart":
					drawChartPreferences();
					break;
				case "meter":
					drawMeterPreferences();
					break;
				case "report":
					break;
			}
			
			for (var i in externalFields) {
				externalFields[i].value = getValue(i, externalFields[i].defaultValue);
			}
			
			if (preferences.adgroup != "static" && dialogArguments.opener.ADSupport) {
				document.all["groupSelectInput"].style.display = "";
				var groupFound = false;
				addGroup(drawUserInfoIds(preferences.aduser, preferences.adgroup), drawUserInfoNames(preferences.adusername, preferences.adgroupname));
			}

			preferences.parameters = getCustomParameters();
			if (preferences.parameters != null) {
				for (var i=0;i<preferences.parameters.length;i++) {
					addField(preferences.parameters[i], "advancedSectionTR");
				}
			}

			drawCategories();
						
			element.document.resizePage();

			handleFilterSection();
		}
		
        function handleFilterSection() {
            var fields = document.getElementById("filterSectionBody").children;
            for (var i=0;i<fields.length;i++) {
                if (fields[i].style.display != "none") {
                    document.getElementById("filterSection").style.display = "";
                    showSection("filterSectionTR");
                    return;
                }
            }
            
            var categories = document.getElementById("categoriesSection").children;
            if (categories.length > 0 && !document.getElementById("categoriesSectionPleaseWait")) {
                document.getElementById("filterSection").style.display = "";
                showSection("filterSectionTR");
                return;
            }
            document.getElementById("filterSection").style.display = "none";
            hideSection("filter");
        }
        
		function hideSection(name) {
			for (var i=0;i<document.all[name+"SectionTR"].length;i++) document.all[name+"SectionTR"][i].style.display = "none";
		}

		function drawUserInfoIds(aduser, adgroup){
			var groupIdsArr = "";
			var userIdsArr = "";
			var groupIds = "";
			var userIds = "";
			
			if (adgroup) {
				groupIdsArr = adgroup.split(',');
				for(var i=0;i<groupIdsArr.length;i++) {
					groupIds += groupIdsArr[i] + ";group,";
				}
				groupIds = groupIds.replace(/,$/, "");
			}
			if (aduser) {
				userIdsArr = aduser.split(',');
				for(var i=0;i<userIdsArr.length;i++) {
					userIds += userIdsArr[i] + ";user,";
				}
				userIds = userIds.replace(/,$/, "");
			}
		
			if (userIds != "" && groupIds != "")
				return(groupIds+","+userIds);
			else if (userIds == "" && groupIds != "")
				return(groupIds);
			else if (userIds != "" && groupIds == "")
				return(userIds);
			else
				return "";
		}
		
		function drawUserInfoNames(adusername, adgroupname){
			if (adusername && adgroupname && adusername != "" && adgroupname != "")
				return(adgroupname+","+adusername);
			else if (adgroupname && adgroupname != "" && (adusername == "" || !(adusername)))
				return(adgroupname);
			else if (adusername != "" && (adgroupname == "" || !(adgroupname)))
				return(adusername);
			else
				return "";
		}
		
		var fieldXML = new ActiveXObject("MSxml.DOMDocument");
		fieldXML.async = false;

		function Field(text) {
			this.text = text;
			
			fieldXML.loadXML(text);
			this.name = fieldXML.documentElement.tagName;
			this.title = fieldXML.documentElement.getAttribute("title");
			this.type = fieldXML.documentElement.getAttribute("type");
			this.value = fieldXML.documentElement.text;
			
			var options = fieldXML.documentElement.getAttribute("selectValues");
			this.options = new Array();
			
			if (options != null) {
				var optionsArr = options.split("|");
				for (var i=0;i<optionsArr.length;i++) {
					this.options[this.options.length] = {value:optionsArr[i].split(":")[1], text:optionsArr[i].split(":")[0]};
				}
			}
		}
		Field.prototype.SetValue = function(value) {
			fieldXML.loadXML(this.text);
			fieldXML.documentElement.text = value;
			return fieldXML.documentElement.xml;
		}

		function addField(fieldText, section) {
			showSection(section);
			var field = new Field(fieldText);

			var tr, td, input;
			tr = document.createElement("tr");
			document.all["preferencesBody"].appendChild(tr);
			
			td = document.createElement("td");
			td.className = "largeTextB";

			switch (field.type) {
				case "checkbox":
					tr.appendChild(td);
					td = null;
					
					td = document.createElement("td");
					td.className = "largeTextB";
					tr.appendChild(td);
					input = document.createElement("<input type='checkbox' name='customparam' id='"+field.name+"'>");
					td.appendChild(input);
					input = null;
					label = document.createElement("label");
					label.htmlFor = field.name;
					label.innerText = field.title;
					td.appendChild(label);
					label = null;
					break;
				case "select":
					td.innerText = field.title+":";
					tr.appendChild(td);

					td = document.createElement("td");
					tr.appendChild(td);
						select = document.createElement("<select class='inputText' name='customparam' id='"+field.name+"'>");
						td.appendChild(select);
						for (var i=0;i<field.options.length;i++) {
							option = document.createElement("option");
							option.value = field.options[i].value;
							option.innerText = field.options[i].text;
							if (option.value == field.value) option.selected = true;
							select.appendChild(option);
							option = null;
						}
						select = null;
					td = null;				
					break;
				case "hidden":
					td.innerText = "*"+field.title+":";
					tr.appendChild(td);
					td = document.createElement("td");
					
						input = document.createElement("<input type='text' class='inputText' name='customparam' id='"+field.name+"'>");
						input.style.width = "130px";
						input.className = "largeInputText";
						input.value = field.value;
						td.appendChild(input);
						input = null;
					tr.appendChild(td);
					tr.style.display = "none";
					break;
				default:
					td.innerText = field.title+":";
					tr.appendChild(td);
					td = document.createElement("td");
					
						input = document.createElement("<input type='text' class='inputText' name='customparam' id='"+field.name+"'>");
						input.style.width = "130px";
						input.className = "largeInputText";
						input.value = field.value;
						td.appendChild(input);
						input = null;
					tr.appendChild(td);
					break;
			}
		}

		function showSection(section) {
			for (var i=0;i<document.all[section].length;i++) document.all[section][i].style.display = "";
		}
		function changeSource(select) {
			document.getElementById("sourceTitle").loaded = false;
			document.getElementById("sourceTitle").title = "";
			
			if (select.options[select.selectedIndex].value == "customize") chooseObject();
			else lastSelectedSource = select.selectedIndex;
		}
		
		function getSource() {
			return document.all["sourceSelect"].options[document.all["sourceSelect"].selectedIndex];
		}
		
		function addSource(value, text) {
			if (value.length != 0 && !value.match(/^(true)?[0-9]*:/)) value = "0:"+value;
			for (var i=0;i<document.all["sourceSelect"].options.length;i++) {
				if (document.all["sourceSelect"].options[i].value == value) {
					document.all["sourceSelect"].selectedIndex = i;
					lastSelectedSource = i;
					return;
				}
			}
			var option = document.createElement("option");
			option.value = value;
			option.innerText = text;
			document.all["sourceSelect"].insertBefore(option, document.all["sourceSelect"].children[document.all["sourceSelect"].children.length-1]);
			document.all["sourceSelect"].selectedIndex = document.all["sourceSelect"].children.length-2;
			option = null;
			lastSelectedSource = document.all["sourceSelect"].selectedIndex;
		}
		
		function chooseObject() {
			var selectedSource = (lastSelectedSource) ? document.all["sourceSelect"].options[lastSelectedSource] : false;
			var treeType = "1";
			if (dialogArguments.opener.isReport) 
				var md = window.showModalDialog("../Tree/treesChooserCont.aspx", {treeType:0, callback:chooseObjectPost, selectedSource:selectedSource, multiple:document.multipleSelection, self:element}, "dialogWidth:300px; dialogHeight:400px; status:no; help:no;");
			else 
				var md = window.showModalDialog("../Tree/treesChooserCont.aspx", {treeType:treeType, callback:chooseObjectPost, selectedSource:selectedSource, multiple:document.multipleSelection, self:element}, "dialogWidth:300px; dialogHeight:400px; status:no; help:no;");

			if (document.all["sourceSelect"].selectedIndex == document.all["sourceSelect"].options.length-1) {
				document.all["sourceSelect"].selectedIndex = lastSelectedSource;
			}
		}

		function chooseObjectPost(entry, treeType, multiple) {
			if (multiple) {
				var entityId = "";
				var entityTree = "";
				var entityName = "";
				var entityValue = "";

				for (var i=0;i<entry.length;i++) {
					entityId += entry[i].id+",";
					entityTree += entry[i].treeType+",";
					entityName += ((entry[i].discard) ? "!" : "")+entry[i].name+", ";
					entityValue += ((entry[i].discard) ? "true:" : "")+entry[i].treeType+":"+entry[i].id+",";
				}
				entityId = entityId.replace(/,$/, "");
				entityValue = entityValue.replace(/,$/, "");
				entityTree = entityTree.replace(/,$/, "");
				entityName = entityName.replace(/, $/, "");

				addSource(entityValue, entityName);
				document.all["entityId"].value = entityId;
				document.all["entityTree"].value = entityTree;
			} else {
				if (entry) {
					addSource(entry.id, entry.name);
					document.all["entityId"].value = entry.id;
					document.all["entityTree"].value = treeType;
				} else {
					addSource("", Constants.currentPage);
					document.all["entityId"].value = "";
					document.all["entityTree"].value = "";
				}
			}
		}	


		function createOption(value, text, selected){
			var option = document.createElement("option");
			option.value = value;
			option.innerText = text;
			option.selected = selected;
			return option;
		}
		
		function createField(name, value) {
			var input = document.createElement("<input type='text' class='inputText' name='genprefs' id='"+name+"'>");
			input.style.width = "50px";
			input.className = "largeInputText";
			input.value = (value) ? value : 0;
			return input;
		}
		
		function createHiddenField(name, value) {
			var input = document.createElement("<input type='hidden' name='genprefs' id='"+name+"'>");
			input.value = value;
			document.body.appendChild(input);
		}
		
		function drawMeterPreferences() {
			var minValue = getValue("MINVALUE", 0);
			var maxValue = getValue("MAXVALUE", 100);
			var undershoot = getValue("UNDERSHOOT", minValue);
			var overshoot = getValue("OVERSHOOT", maxValue);
			
			showSection("meterSectionTR");
			document.all["meterSection"].style.display = "";
			
			document.all["minValue"].value = minValue;
			document.all["minValue"].orgValue = minValue;
			document.all["maxValue"].value = maxValue;
			document.all["maxValue"].orgValue = maxValue;
			document.all["undershoot"].value = undershoot;
			document.all["undershoot"].orgValue = undershoot;
			document.all["overshoot"].value = overshoot;
			document.all["overshoot"].orgValue = overshoot;
		}
		
		function drawChartPreferences() {
			rules = element.xmlObj.selectNodes(".//RULES/RULE");
			for (var i=0;i<rules.length;i++) {
				var ruleId = rules[i].getAttribute("id");
				var tr, td, input, span;
				
				tr = document.createElement("tr");
				tr.id = "__rule"+ruleId;
				tr._id = ruleId;
				document.all["rulesBody"].appendChild(tr);
				
					td = document.createElement("td");
						input = document.createElement("<input type='checkbox' class='inputCheckbox' id='__ruleStatus"+ruleId+"' "+((rules[i].getAttribute("status") == null || rules[i].getAttribute("status") == "on") ? "checked='true'" : "")+">");
						td.appendChild(input);
						input = null;
					tr.appendChild(td);
					td = null;

					td = document.createElement("td");
					td.innerText = rules[i].getAttribute("title");
					tr.appendChild(td);
					td = null;

					td = document.createElement("td");
					tr.appendChild(td);
						if (rules[i].getAttribute("period") != null) {
							input = document.createElement("<input type='text' class='inputText' size='3' style='width:30px;' id='__rulePeriod"+ruleId+"' _id='"+ruleId+"'>");
							input.onblur = function() {
								if (this.value.match(/[^0-9]/) || this.value == "") this.value = 1;
								else if (this.value == 0) document.all["__ruleStatus"+this._id].checked = false;
								else document.all["__ruleStatus"+this._id].checked = true;
								document.all["__ruleSpan"+this._id].innerText = getPeriod(this._id);
							}
							td.appendChild(input);
							input.value = rules[i].getAttribute("period");

							span = document.createElement("span");
							span.innerText = " ";
							td.appendChild(span);

							span = document.createElement("span");
							span.id = "__ruleSpan"+ruleId;
							span.innerText = getPeriod(ruleId);
							td.appendChild(span);
							span = null;
						}
						if (rules[i].getAttribute("dual") != null && rules[i].getAttribute("dual") == "true") {
							span = document.createElement("span");
							span.id = "__ruleDual"+ruleId;
							span.innerText = "Runs as a Dual Y Line";
							td.appendChild(span);
							span = null;
						}
					td = null;
					
				tr = null;
			}
		}
		
		function getPeriod(id) {
			var unit = document.all["__rulePeriod"+id].value;
			var unitType = document.all["timeFrame"].options[document.all["timeFrame"].selectedIndex].innerHTML;
			return unitType+((unit != 1) ? "s" : "")+" ago";
		}
		
		function addCustomizedOption(timeInterval, start, end, title) {
			var option = document.createElement("option");
			option.value = "0";
			option.timeFrameStart = start;
			option.timeFrameEnd = end;
			option.timeInterval = timeInterval;
			option.innerText = title;
			return option;
		}

		function flatDate(value, hours, minutes, seconds) {
			function lpad(value) {
				value = value+"";
				if (value.length == 1) return "0"+value;
				else return value;
			}
			return value.getYear()+lpad(value.getMonth()+1)+lpad(value.getDate())+lpad(hours)+lpad(minutes)+lpad(seconds);
		}
		
		function findOption(select, option) {
			for (var i=0;i<select.options.length;i++) {
				if (select.options[i].value == option.value && select.options[i].innerText == option.innerText) return select.options[i];
			}
			return false;
		}
		
		function setDateRange(timeInterval, start, end, title, dynamic) {
			if (!end) end = new Date();
			end = new Date(end.setHours(23, 59, 59));
			var option;
			
			if (!dynamic)
				option = addCustomizedOption(timeInterval, flatDate(start, 0, 0, 0), flatDate(end, 0, 0, 0), title);
			else
				option = addCustomizedOption(timeInterval, start, "today", title);
			
			var existingOption = findOption(document.all["timeFrame"], option);
			if (existingOption) existingOption.selected = true;
			else {
				document.all["timeFrame"].insertBefore(option, document.all["timeFrame"].options[document.all["timeFrame"].options.length-1]);
				document.all["timeFrame"].selectedIndex = document.all["timeFrame"].options.length-2;
			}
			lastSelectedTimeFrame = document.all["timeFrame"].selectedIndex;
			option = null;
		}
		
		function changeUnitType(obj) {
			if (obj.options[obj.selectedIndex].value == "customize") {
				chooseDateRange();
				return;
			} else {
				lastSelectedTimeFrame = obj.selectedIndex;
			}
		}

		function chooseDateRange() {
			function cancelCallback() {
				document.all["timeFrame"].selectedIndex = lastSelectedTimeFrame;
			}
			window.showModelessDialog("cont.aspx", {title:"<%=CardioLog.API.Localization.getText("$Choose Date Range$")%>", href:"chooseDateRange.aspx", self:self, option:(lastSelectedTimeFrame >= 0) ? document.all["timeFrame"].options[lastSelectedTimeFrame] : false, currentTimeInterval:false, callback:setDateRange, cancelCallback:cancelCallback}, "dialogHeight:390px; dialogWidth:530px; status:no; help:no;");
		}
		
		var lastSelectedTimeFrame = false;
		var lastSelectedSource = false;

		function setPreferencesTemporarily() {
			eval(element.callback+"();");
		}
		
		var periods = new Array();
		
		function setMandatoryContext(state) {
			if (state) {
				if (document.all["sourceSelect"].options[document.all["sourceSelect"].selectedIndex].value == Constants.currentPage) {
					if (state) document.all["sourceSelect"].options[0].innerText = Constants.unknownPage;
				}
				element.mandatoryContext = true;
			}
		}
		
		function getEntityUrl() {
			return document.all["entityUrl"].value;
		}
		function isStatic() {
			return (document.all["chooseEntity"].style.display == "") ? false : true;
		}
		function getEntityId() {
			return (document.all["chooseEntity"].style.display == "") ? document.all["entityId"].value : "static";
		}
		
		function getTimeFrame() {
			var timeFrame = document.all["timeFrame"].options[document.all["timeFrame"].selectedIndex].innerHTML;
			return timeFrame;
		}
		
		function initPeriods(defaultValue, extraOption) {
            var realTime = "<%=realTime%>";
		    switch (element.type) {
				case "meter":
				    if(realTime == "True")
				    {
					    var periods = new Array({value:600000000, text:'<%=CardioLog.API.Localization.getText("$Hour$")%>'},
									{value:36000000000, text:'<%=CardioLog.API.Localization.getText("$Day$")%>'},
									{value:864000000000, text:'<%=CardioLog.API.Localization.getText("$Week$")%>'},
									{value:6048000000000, text:'<%=CardioLog.API.Localization.getText("$Month$")%>'},
									{value:25920000000000, text:"<%=CardioLog.API.Localization.getText("$Quarter$")%>"},
									{value:77760000000000, text:"<%=CardioLog.API.Localization.getText("$Year$")%>"});
		            }
			        else
			        {
			            var periods = new Array({value:36000000000, text:'<%=CardioLog.API.Localization.getText("$Day$")%>'},
									        {value:864000000000, text:'<%=CardioLog.API.Localization.getText("$Week$")%>'},
									        {value:6048000000000, text:'<%=CardioLog.API.Localization.getText("$Month$")%>'},
									        {value:25920000000000, text:"<%=CardioLog.API.Localization.getText("$Quarter$")%>"},
									        {value:77760000000000, text:"<%=CardioLog.API.Localization.getText("$Year$")%>"});
			        }
					break;
				case "report":
				    if(realTime == "True")
				    {
					    var periods = new Array({value:600000000, text:'<%=CardioLog.API.Localization.getText("$Hour$")%>'},
									{value:36000000000, text:'<%=CardioLog.API.Localization.getText("$Day$")%>'},
									{value:864000000000, text:'<%=CardioLog.API.Localization.getText("$Week$")%>'},
									{value:6048000000000, text:'<%=CardioLog.API.Localization.getText("$Month$")%>'},
									{value:25920000000000, text:"<%=CardioLog.API.Localization.getText("$Quarter$")%>"},
									{value:77760000000000, text:"<%=CardioLog.API.Localization.getText("$Year$")%>"});
	                }
		            else
		            {
		                var periods = new Array({value:36000000000, text:'<%=CardioLog.API.Localization.getText("$Day$")%>'},
								            {value:864000000000, text:'<%=CardioLog.API.Localization.getText("$Week$")%>'},
								            {value:6048000000000, text:'<%=CardioLog.API.Localization.getText("$Month$")%>'},
								            {value:25920000000000, text:"<%=CardioLog.API.Localization.getText("$Quarter$")%>"},
								            {value:77760000000000, text:"<%=CardioLog.API.Localization.getText("$Year$")%>"});
		            }
					break;
			}
			var option;
			for (var i=0;i<periods.length;i++) {
			    // Remove This Day
			    if (periods[i].value != "36000000000" || realTime == "True") {
				    option = createOption(periods[i].value, "<%=CardioLog.API.Localization.getText("$This$")%> "+periods[i].text);
				    if (defaultValue == periods[i].value) {
					    option.selected = true;
					    lastSelectedTimeFrame = i*2;
				    }
				    document.all["timeFrame"].appendChild(option);
				    option = null;
				}

				option = createOption(-periods[i].value, "<%=CardioLog.API.Localization.getText("$Last$")%> "+periods[i].text);
				if (defaultValue < 0 && Math.abs(defaultValue) == periods[i].value) {
					option.selected = true;
					lastSelectedTimeFrame = i*2+1;
				}
				document.all["timeFrame"].appendChild(option);
				option = null;
			}

			if (extraOption) {
				document.all["timeFrame"].appendChild(extraOption);
//				document.all["timeFrame"].selectedIndex = document.all["timeFrame"].options.length-1;
				extraOption.selected = true;
				lastSelectedTimeFrame = document.all["timeFrame"].options.length-1;
			}
			
			option = createOption("customize", "<%=CardioLog.API.Localization.getText("$Customize$")%>...");
			document.all["timeFrame"].appendChild(option);
			option = null;
		}
		
		function isNumeric(obj) {
			if (obj.value.match(/[^0-9]/) || obj.value == "") obj.value = obj.orgValue;
			else obj.orgValue = obj.value;
		}
		
		function toggleSection(name, obj) {
			document.all[name+"Section"].style.display = (document.all[name+"Section"].style.display == "none") ? "" : "none";
			obj.children[0].src = (obj.children[0].src.match(/minus/i)) ? obj.children[0].src.replace(/minus/i, "plus") : obj.children[0].src.replace(/plus/i, "minus");
		}

		var lastSelectedGroup = false;

		function changeAuthentication(select) {
			if (select.options[select.selectedIndex].value == "customize") chooseAuthentication();
			else lastSelectedGroup = select.selectedIndex;
		}

		function chooseAuthenticationPost(groups, ids) {
			addGroup(ids, groups);	
		}

		function chooseAuthentication() {
			var selectedGroup = (lastSelectedGroup) ? document.all["groupSelect"].options[lastSelectedGroup] : false;
			var md = window.showModalDialog("cont.aspx", {href:"ADChooser.aspx", selectedGroup:selectedGroup, title:"<%=CardioLog.API.Localization.getText("$Select Users and Groups$")%>", type:null, callback:chooseAuthenticationPost, self:element}, "dialogWidth:300px; dialogHeight:420px; status:no; help:no;");
			if (document.all["groupSelect"].selectedIndex == document.all["groupSelect"].options.length-1) {
				document.all["groupSelect"].selectedIndex = lastSelectedGroup;
			}
		}

		function addGroup(value, text) {
			for (var i=0;i<document.all["groupSelect"].options.length;i++) {
				if (document.all["groupSelect"].options[i].value == value) {
					document.all["groupSelect"].selectedIndex = i;
					lastSelectedGroup = i;
					return;
				}
			}
			var option = document.createElement("option");
			option.value = value;
			option.innerText = text;
			document.all["groupSelect"].insertBefore(option, document.all["groupSelect"].children[document.all["groupSelect"].children.length-1]);
			document.all["groupSelect"].selectedIndex = document.all["groupSelect"].children.length-2;
			option = null;
			lastSelectedGroup = document.all["groupSelect"].selectedIndex;
		}

		function showPath() {
			var sourceTitle = document.getElementById("sourceTitle");
			if (!sourceTitle.loaded) {
				sourceTitle.loaded = true;
				sourceTitle.title = "<%=CardioLog.API.Localization.getText("$Loading path. Please wait$")%>...";

				var ids = getSource().value.split(",");
				if (ids == "") return;
				for (var i=0;i<ids.length;i++) {
					ids[i] = ids[i].replace(/^[0-9]\:/, "");
				}

				element.document.getPath(ids.join(","), displayPath);
			}
		}
		function displayPath(message, error) {
			document.getElementById("sourceTitle").title = message;
		}
		function toggleHelp() {
			var shouldHide = (document.all["helpSection"].style.display == "") ? true : false;
			toggleSection("help", document.all["helpSectionTR"][0].children[0]);
			if (!shouldHide) document.all["helpSectionTR"][0].scrollIntoView();
		}
		function setAbout(value) {
			document.getElementById("aboutContent").innerHTML = value;
		}
	</script>
</head>
<body style="border:0px; padding:10px; ">
	<table border="0" cellpadding="5" cellspacing="0" width="100%" height="100%" style="table-layout:fixed;">
		<tr id="appearanceSectionTR"><td class="largeTextBoldB"><img style="cursor:hand;" onclick="toggleSection('appearance', this.parentElement);" src="/Cardiolog/images/plus.gif" align="absmiddle"> <%=CardioLog.API.Localization.getText("$Appearance$")%></td></tr>
		<tr id="appearanceSectionTR"><td class="groupSeparator"></td></tr>
		<tr id="appearanceSection" style="display:none;"><td>
					<table border="0" cellpadding="5" cellspacing="0">
						<tr><td class="largeTextB"><input type="checkbox" id="showPreferences"><label for="showPreferences"><%=CardioLog.API.Localization.getText("$Show preferences$")%></label></td></tr>
						<tr><td class="largeTextB"><input type="checkbox" id="showHelp"><label for="showHelp"><%=CardioLog.API.Localization.getText("$Show help$")%></label></td></tr>
						<tr id="categoriesSectionTR" style="display:;"><td>
					        <table border="0" cellpadding="5" cellspacing="0">
						        <tbody id="categoriesBody"></tbody>
					        </table>
				        </td></tr>
					</table>
				</td></tr>
		<tr id="appearanceSectionTR"><td height="10px"></td></tr>
		<tr id="filterSectionTR"><td class="largeTextBoldB"><img style="cursor:hand;" onclick="toggleSection('filter', this.parentElement);" src="/Cardiolog/images/minus.gif" align="absmiddle"> <%=CardioLog.API.Localization.getText("$Filter$")%></td></tr>
		<tr id="filterSectionTR"><td class="groupSeparator"></td></tr>
		<tr id="filterSection" style="display:;"><td>
					<table border="0" cellpadding="5" cellspacing="0">
						<thead id="filterSectionBody">
							<tr id="chooseDateRange"><td class="largeTextB">
										<%=CardioLog.API.Localization.getText("$Date Range$")%>:<br>
										<select id="timeFrame" class="largeInputSelect" onchange="changeUnitType(this)" style="width:180px;"></select></td>
							</tr>
							<tr id="chooseEntity"><td class="largeTextB" onmouseover="showPath()">
										<span id="sourceTitle"><%=CardioLog.API.Localization.getText("$Source$")%>:</span><br>
										<select id="sourceSelect" class="largeInputSelect" onchange="changeSource(this)" style="width:180px;">
											<option value=""><%=CardioLog.API.Localization.getText("$Current Page$")%></option>
											<option value="customize"><%=CardioLog.API.Localization.getText("$Customize$")%>...</option>
										</select>
										<input type="hidden" id="entityId"><input type="hidden" id="entityTree"></td>
							</tr>
							<tr id="chooseEntityUrl"><td class="largeTextB">
										<%=CardioLog.API.Localization.getText("$Source$")%>:<br>
										<input type="text" id="entityUrl" style="width:180px" class="largeInputText">
							</tr>
							<tr id="groupSelectInput" style="display:none;"><td class="largeTextB">
										<%=CardioLog.API.Localization.getText("$Users and Groups$")%>:<br>
										<select id='groupSelect' class="largeInputSelect" style="width:180px;" onchange="changeAuthentication(this)">
											<option value=''><%=CardioLog.API.Localization.getText("$All$")%></option>
											<option value='customize'><%=CardioLog.API.Localization.getText("$Customize$")%>...</option>
										</select>
							</tr>
						</thead>
						<tfoot id="categoriesSection">
							<tr id="categoriesSectionPleaseWait" style="display:none;">
								<td class="largeTextB"><%=CardioLog.API.Localization.getText("$Loading Categories$")%>...</td>
							</tr>
						</tfoot>
					</table>		
				</td></tr>
		<tr id="filterSectionTR"><td height="10px"></td></tr>
		<tr id="advancedSectionTR" style="display:none;"><td class="largeTextBoldB"><img style="cursor:hand;" onclick="toggleSection('advanced', this.parentElement);" src="/Cardiolog/images/minus.gif" align="absmiddle"> <%=CardioLog.API.Localization.getText("$Advanced$")%></td></tr>
		<tr id="advancedSectionTR" style="display:none;"><td class="groupSeparator"></td></tr>
		<tr id="advancedSection" style="display:;"><td>
					<table border="0" cellpadding="5" cellspacing="0">
						<tbody id="preferencesBody"></tbody>
					</table>
				</td></tr>
		<tr style="display:none;" id="advancedSectionTR"><td height="10px"></td></tr>
		<tr id="meterSectionTR" style="display:none;"><td class="largeTextBoldB"><img style="cursor:hand;" onclick="toggleSection('meter', this.parentElement);" src="/Cardiolog/images/minus.gif" align="absmiddle"> <%=CardioLog.API.Localization.getText("$Meter Preferences$")%></td></tr>
		<tr id="meterSectionTR" style="display:none;"><td class="groupSeparator"></td></tr>
		<tr id="meterSection" style="display:none;"><td>
					<table border="0" cellpadding="5" cellspacing="0">
						<tr><td class="largeTextB"><%=CardioLog.API.Localization.getText("$Min Value$")%>:</td>
							<td><input type="text" id="minValue" style="width:50px;" class="largeInputText" onblur="isNumeric(this);"></td>
						</tr>
						<tr><td class="largeTextB"><%=CardioLog.API.Localization.getText("$Max Value$")%>:</td>
							<td><input type="text" id="maxValue" style="width:50px;" class="largeInputText" onblur="isNumeric(this);"></td>
						</tr>
						<tr><td class="largeTextB"><%=CardioLog.API.Localization.getText("$Undershoot$")%>:</td>
							<td><input type="text" id="undershoot" style="width:50px;" class="largeInputText" onblur="isNumeric(this);"></td>
						</tr>
						<tr><td class="largeTextB"><%=CardioLog.API.Localization.getText("$Overshoot$")%>:</td>
							<td><input type="text" id="overshoot" style="width:50px;" class="largeInputText" onblur="isNumeric(this);"></td>
						</tr>
					</table>
				</td></tr>
		<tr style="display:none;" id="advancedSectionTR"><td height="10px"></td></tr>

		<tr style="display:none;">
			<td>
				<table border="0" cellpadding="3" cellspacing="0" class="regTextB">
					<tfoot id="rulesBody"></tfoot>
				</table>
			</td>
		</tr>			
		<tr id="helpSectionTR"><td class="largeTextBoldB"><img style="cursor:hand;" onclick="toggleSection('help', this.parentElement);" src="/Cardiolog/images/plus.gif" align="absmiddle"> <%=CardioLog.API.Localization.getText("$About this$")%> <span id='aboutThisSpan'></span></td></tr>
		<tr id="helpSectionTR"><td class="groupSeparator"></td></tr>
		<tr id="helpSection" style="display:none;" class="largeTextB"><td id="aboutContent">
				</td></tr>
		<tr id="helpSectionTR"><td height="10px"></td></tr>
	</table>
</body>
</html>