//var FRIENDLY_URL_PREFIX = "http://intl.ck/";
function getAdminCode() {
	return "345234123.235523424";
}

var days = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];

function __sc(b, c, d) {
	var expires = "";
	if (typeof(d) != "undefined") {
		var a = new Date();
		a.setTime(a.getTime() + d * 24 * 60 * 60 * 1000);
		expires = "; expires="+a.toGMTString();
	}
	var domain = "";
	if (domain.match(/\./)) domain = ";domain="+document.domain.replace(/^[\w]*/, "");

	document.cookie = b + "=" + c + expires + "; path=/"+domain;
}

function __rc(a) {
	var b = new RegExp(a + "=([^;]*)", "i");
	var c = document.cookie.match(b);
	return (c && c.length == 2) ? c[1] : null
}

function __dc(a) {
	__sc(a, "", -1);
}

function injectjs(url, cachebuster) {
    if (cachebuster) {
    	url += ((url.match(/\?/)) ? "&" : "?")+"_random="+Math.random();
    }
    var ca = document.createElement('script'); ca.type = 'text/javascript'; ca.async = true;
    ca.src = url;
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ca, s);
}
var Loader = {
	show:function(value, block, delay) {
		window.clearInterval(Loader.hideinterval);
		if (value) $("#loader").html(value);
		$("#loader").show();
		if (block) $("#overlay").show();
		else $("#overlay").hide();
		if (delay) Loader.hide(delay);
	}, 
	hide:function(delay) {
		if (typeof(delay) != "undefined") {
			Loader.hideinterval = window.setTimeout(function() {
				$("#loader").hide();
				$("#overlay").hide();
			}, delay);
		} else {
			$("#loader").hide();
			$("#overlay").hide();
		}
	},
	showonnextpage:function(url, message, delay) {
		__sc("_message", message);
		__sc("_delay", delay);
		document.location.href = url;
	}
}
function closepopup() {
    try {
        parent.hideSecondaryPopup();
    } catch (e) {
        parent.hidePopup();
    }
}

function Test(data, type) {
	this.data = data;
	this.exists = (data != null);
	if (type) this.data.type = type;
}
Test.prototype.Pause = function() {
	this.data.status = "paused";
}
Test.prototype.Resume = function() {
	this.data.status = "live";
}
Test.prototype.Stop = function() {
	this.data.status = "ended";
	this.data.endtime = (new Date()).getTime();
}
Test.prototype.Start = function() {
	this.data.status = "live";
	this.data.starttime = (new Date()).getTime();
}
Test.prototype.GetType = function(display) { 
	if (this.data.type_id == 1) return "Split";
	else if (this.data.type_id == 2) return "MVT";
	else if (this.data.type_id == 3) return "AB";
}
Test.prototype.GetTitle = function(plain) {
	return this.data.title+((plain) ? "" : " ("+this.data.type+")");
}
Test.prototype.GetStatus = function() {
	return this.data.status;
}
Test.prototype.GetStartTime = function() {
	if (this.data.starttime == null) return formattimestamp();
	else return formattimestamp(this.data.starttime);
}
Test.prototype.GetEndTime = function() {
	return formattimestamp(this.data.endtime);
}
Test.prototype.GetParticipants = function() {
	return formatunits(this.data.visitors, "", "");
}
Test.prototype.GetConversions = function() {
	return formatunits(this.data.conversions, "", "");
}
Test.prototype.GetConversionRate = function() {
	return formatpercentage(this.data.conversionrate);
}

Test.prototype.GetOriginal = function() {
	for (var i=0;i<this.data.variations.length;i++) {
		if (this.data.variations[i].type == "original") return this.data.variations[i];
	}
}

function Variation(obj) {
	this.data = obj;
}
Variation.prototype.GetCombination = function() {
	var output = [];
	for (var i=0;i<this.data.combination.length;i++) {
		output.push(this.data.combination[i].variationtitle);
	}
	return output.join(", ");
}
Variation.prototype.GetCombinationTitle = function() {
	var output = [];
	for (var i=0;i<this.data.combination.length;i++) {
		output.push(this.data.combination[i].uielementtitle);
	}
	return output.join(", ");
}
Test.prototype.GetOriginalVariation = function(pageid) {
	var arr = [];
	var page = Pages.Get(pageid);
	
	var variation = {"title":"Original", combination:[], "status":"active", "percentage":100};

	if (page.exists) {
		for (var i=0;i<page.data.uielements.length;i++) {
			var element = UIElements.Get(page.data.uielements[i].id);
			variation.combination.push({ "uielementid": element.data.id, "uielementtitle": element.data.title, "variationtitle": "Default"});
		}
	}
	arr.push(variation);
	return arr;
}
Test.prototype.GetVariations = function(includeoriginal) {
	var arr = [];
	for (var i=0;i<this.data.variations.length;i++) {
		if (includeoriginal || this.data.variations[i].type != "original") arr.push(this.data.variations[i]);
	}
	return arr;
}
Test.prototype.GetVariation = function(id) {
	var i = this.data.variations.length;
	while (i--) {
		if (this.data.variations[i].id == id) return this.data.variations[i];
	}
	return null;
}
Test.prototype.GetBestConvertingVariation = function() {
	var c = 0;
	var v = null;
	for (var i=0;i<this.data.variations.length;i++) {
		if (this.data.variations[i].conversionrate >= c) {
			c = this.data.variations[i].conversionrate;
			v = this.data.variations[i];
		}
	}
	return v;
}
Test.prototype.GetBestConvertingText = function() {
	var v = this.GetBestConvertingVariation();
	return v.title+" ("+formatpercentage(v.conversionrate)+")";
}
Test.prototype.GetBestConvertingLink = function() {
	var v = this.GetBestConvertingVariation();
	var variationtitle = this.GetVariationDescription(v.id);
	return "<a href='javascript:previewvariation("+this.data.id+", "+v.id+");' title=\""+variationtitle+"\">"+this.GetBestConvertingText()+"</a>";
}
Test.prototype.GetVariationDescription = function(id) {
	var variation = this.GetVariation(id);
	if (variation != null) {
		if (this.data.type == "AB") return variation.pageurl;

		var output = [];
		for (var c=0;c<variation.combination.length;c++) {
			output.push(variation.combination[c].uielementtitle+" - "+variation.combination[c].variationtitle);
		}
		return output.join("\n");
	
	}
	return "";
}
var Tests = {};
Tests.Get = function(id, type) {
	if (typeof(type) == "undefined" || type == "split") {
		var i = abTests.length;
		while (i--) {
			if (abTests[i].type_id == 1 && abTests[i].id == id) return new Test(abTests[i], "AB");
		}
	}
	if (typeof(type) == "undefined" || type == "MVT") {
		var i = mvtTests.length;
		while (i--) {
			if (mvtTests[i].type_id != 1 && mvtTests[i].id == id) return new Test(mvtTests[i], "MVT");
		}
	}	
	return new Test(null);
}

var Messagebars = {};
Messagebars.New = function() {
	document.location.href = "toolbar.aspx?id=-1";
}
Messagebars.Edit = function(id) {
	document.location.href = "toolbar.aspx?id="+id;
}
Messagebars.Preview = function(content) {
	__CAmb.pause(content);
}	
Messagebars.ConfirmDelete = function(id) {
	var myJSONObject =
									{ "popupArguments":
									[
									 { title: "Delete Message Bar", href: "/CardioLog/MarketingSuite/toolbar/delete-toolbar.aspx", callback: Messagebars.Delete, "toolbarid": id, self: top }
									 ]
									};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/toolbar/delete-toolbar.aspx", 171, 700, myJSONObject);
}
Messagebars.ConfirmFlush = function(id) {
	var myJSONObject =
									{ "popupArguments":
									[
									 { title: "Flush Message Bar", href: "/CardioLog/MarketingSuite/toolbar/flush-toolbar.aspx", callback: Messagebars.Flush, "toolbarid": id, self: top }
									 ]
									};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/toolbar/flush-toolbar.aspx", 171, 700, myJSONObject);
}
Messagebars.Delete = function(id) {
	Loader.show("Deleting message bar...", true);
	Server.DeleteToolbar(id, function() {
		Loader.hide();
		document.location.href = "index.aspx";
	});
}
Messagebars.Flush = function(id) {
	Loader.show("Flushing message bar...", true);
	Server.FlushToolbar(id, function() {
		Loader.show("Done.", false, 5);
	});
}
var Surveys = {};
Surveys.New = function() {
    document.location.href = "survey.aspx?id=-1";
}
Surveys.Edit = function(id) {
	document.location.href = "survey.aspx?id="+id;
}
Surveys.ShowReport = function(id) {
	document.location.href = "survey-results.aspx?id="+id;
}
Surveys.Preview = function(id, obj) {
	__CAs.dispose();
		obj.id = id;
    if (typeof(obj) != "undefined") __CAs.init(obj);
    else {
		var i = surveys.length;
		while (i--) {
			if (surveys[i].id == id) {
				__CAs.init(surveys[i]);
				break;
			}
		}
	}
}
Surveys.ConfirmDelete = function(id) {
	var myJSONObject =
		{ "popupArguments":
			[
				{ title: "Delete Survey", href: "/CardioLog/MarketingSuite/VOC/delete-survey.aspx", callback: Surveys.Delete, "surveyid": id, self: top }
			]
		};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/VOC/delete-survey.aspx", 171, 700, myJSONObject);
}
Surveys.ConfirmFlush = function(id) {
	var myJSONObject =
		{ "popupArguments":
			[
				{ title: "Flush Survey", href: "/CardioLog/MarketingSuite/VOC/flush-survey.aspx", callback: Surveys.Flush, "surveyid": id, self: top }
			]
		};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/VOC/flush-survey.aspx", 171, 700, myJSONObject);
}
Surveys.Delete = function(id) {
	Loader.show("Deleting survey...", true);
	Server.DeleteSurvey(id, function() {
		Loader.hide();
		document.location.href = "index.aspx";
	});
}
Surveys.Flush = function(id) {
	Loader.show("Flushing survey...", true);
	Server.FlushSurvey(id, function() {
		Loader.show("Done.", false, 5);
	});
}

var Segments = {};
Segments.Get = function(id) {
	var i = segments.length;
	while (i--) {
		if (segments[i].id == id) return new Segment(segments[i]);
	} 
	return new Segment(null);
}
Segments.ConfirmDelete = function(id) {
	var pos = Segments.Find(id);
	if (pos != -1) {
	    var myJSONObject =
			                { "popupArguments":
			                [
			                 { title: "Add Pixel", href: "/CardioLog/MarketingSuite/Segments/delete-segment.aspx", callback: Segments.Delete, "title": segments[pos].title, "segmentid": id, "content": segments[pos].content, "test": segments[pos].test, self: top }
			                 ]
			                };
	    parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/Segments/delete-segment.aspx", 171, 700, myJSONObject);
	}
}
Segments.Delete = function(id) {
	function callback(status) {
		Loader.hide();
		var pos = Segments.Find(id);
		if (pos != -1) segments.splice(pos, 1);

		drawsegments();
	}
	Loader.show("Deleting segment...", true);
	Server.DeleteSegment(id, callback);
}
Segments.Edit = function(id) {
	document.location.href = "segment.aspx?id="+id;
}
Segments.Find = function(id) {
	for (var i=0,ii=segments.length;i<ii;i++) {
		if (segments[i].id == id) {
			return i;
		}
	}
	return -1;
}
Segments.Save = function(data, callback) {
	try {
		console.info(data);
	} catch (e) {
	}
	callback();
}
Segments.New = function() {
    document.location.href = "segment.aspx?id=-1";
}
Segments.GetTitle = function(id) {
	var pos = Segments.Find(id);
	if (pos != -1) return segments[pos].title;
	else return "";
}
Segments.FindShortenLink = function(name, term) {
	var i = segments.length;
	while (i--) {
		var definitions = segments[i].definition;
		if (definitions.length == 2 && 
					definitions[0]["n"] == "campaign" && definitions[0]["v"] == name && definitions[0]["c"] == "me" &&
					definitions[1]["n"] == "term" && definitions[1]["v"] == term&& definitions[1]["c"] == "me") return segments[i];
	}
	return null;
}
Segments.FindTrackingLink = function(name) {
	var i = segments.length;
	while (i--) {
		if (segments[i].title == "Tracking Link: "+name) {
			return segments[i];
		}
	}
	return null;
}
Segments.old_FindTrackingLink = function(name, term, content) {
	var numberofconditions = 1+(term == "" ? 0 : 1)+(content == "" ? 0 : 1);
	var i = segments.length;
	while (i--) {
		var definitions = segments[i].definition;
		if (definitions.length == numberofconditions) {
			var found = true;
			for (var d=0;d<definitions.length;d++) {
				switch (definitions[d]["n"]) {
					case "name":
						if (definitions[d]["v"] != name && definitions[d]["c"] != "me") {
							found = false
							break;
						}
						break;
					case "term":
						if (definitions[d]["v"] != term && definitions[d]["c"] != "me") {
							found = false
							break;
						}
						break;
					case "content":
						if (definitions[d]["v"] != content && definitions[d]["c"] != "me") {
							found = false
							break;
						}
						break;
					default:
						found = false;
						break;
				}
			}
			if (found) return segments[i];
		}
	}
	return null;
}
Segments.FindCampaign = function(name) {
	var i = segments.length;
	while (i--) {
		var definitions = segments[i].definition;
		if (definitions.length == 1 && definitions[0]["n"] == "campaign" && definitions[0]["v"] == name && definitions[0]["c"] == "me") return segments[i];
	}
	return null;
}
Segments.CreateAtlasCampaign = function(type, obj, callback) {
	var definition = [];
	var title = [];
	definition.push("score,0");
	definition.push("stype,lifetime");
	title.push(obj.mediaplan.name);

	switch (type) {
		case "mediaplan":
			definition.push("campaign,me,"+obj.mediaplan.name);
			break;
		case "buy":
			definition.push("campaign,me,"+obj.mediaplan.name);
			definition.push("source,me,"+obj.buy.name);
			title.push(obj.buy.name);
			break;
		case "placement":
			//definition.push("source,me,"+obj.buy.name);
			title.push(obj.buy.name);
			definition.push("term,me,"+obj.placement.id);
			title.push(obj.placement.name);
			break;
		case "creative":
			//definition.push("source,me,"+obj.buy.name);
			title.push(obj.buy.name);
			//definition.push("term,me,"+obj.placement.id);
			title.push(obj.placement.name);
			definition.push("content,me,"+obj.creative.id);
			title.push(obj.creative.name);
			break;
	}
	Server.SaveSegment("-1", "Atlas: "+title.join(" > "), "segment", definition.join("|"), callback);
}
Segments.SetAtlasMediaPlans = function(type, segmentid, ids, callback) {
	Server.UpdateAtlasMediaPlansSegmentId(type, segmentid, ids, callback);
}
Segments.FindAtlasCampaign = function(type, obj) {
	var definitionscount = 1;
	var definitions = {};
	definitions["campaign"] = {"v":obj.mediaplan, "c":"me"};
	switch (type) {
		case "buy":
			definitions["source"] = {"v":obj.buy, "c":"me"};
			definitionscount = 2;
			break;
		case "placement":
			definitions["source"] = {"v":obj.buy, "c":"me"};
			definitions["term"] = {"v":obj.placement, "c":"me"};
			definitionscount = 3;
			break;
		case "creative":
			definitions["source"] = {"v":obj.buy, "c":"me"};
			definitions["term"] = {"v":obj.placement, "c":"me"};
			definitions["content"] = {"v":obj.creative, "c":"me"};
			definitionscount = 4;
			break;
	}

	var i = segments.length;
	while (i--) {
		var found = true;
		if (segments[i].definition.length-2 == definitionscount) {
			for (var d=0;d<segments[i].definition.length;d++) {
				if (segments[i].definition[d].n == "score" || segments[i].definition[d].n == "stype") continue;
				if (typeof(segments[i].definition[d].internal) != "undefined" && segments[i].definition[d].internal) continue;
				if (typeof(definitions[segments[i].definition[d].n]) != "undefined" && 
							unescape(definitions[segments[i].definition[d].n].v) == unescape(segments[i].definition[d].v) && 
							definitions[segments[i].definition[d].n].c == segments[i].definition[d].c) {
				} else {
					found = false;
				}
			}
		} else {
			found = false;
		}
		if (found) return segments[i];
	}
	return null;
}
var Affiliates = {};
Affiliates.Edit = function(id) {
//	document.location.href = 'affiliate.aspx?id='+id;
}
Affiliates.New = function() {
//	document.location.href = 'affiliate.aspx?id=-1';
}

var Campaigns = {};
Campaigns.ConfirmHide = function(id) {
	var campaign = Campaigns.Get(id);
	if (campaign != null) {
	    var myJSONObject =
			                { "popupArguments":
			                [
			                 { title: "Hide Campaign", href: "/CardioLog/MarketingSuite/Campaigns/hide-campaign.aspx", callback: Campaigns.Hide, "name": campaign.name, "campaignid": campaign.id, "clicks":campaign.clicks, "activity": formattimestamptohours(campaign.lastClickDate), self: top }
			                 ]
			                };
	    parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/Campaigns/hide-campaign.aspx", 171, 700, myJSONObject);
	}
}
Campaigns.Hide = function (id) {
    function callback(status) {
        Loader.hide();
        document.location.href = "index.aspx";
    }
    function campaign_segment_callback(status) {
        Loader.show("Deleting campaign segment...", true);
        var campaign = Campaigns.Get(id);
        var segment = Campaigns.FindSegment(campaign.name);
        Server.DeleteSegment(segment.id, callback);
    }

    Loader.show("Hiding campaign...", true);
    Server.HideCampaign(id, campaign_segment_callback);
}

Campaigns.FindSegment = function (name) {
    var i = segments.length;
    while (i--) {
        if (segments[i].title == "Campaign: " + name) {
            return segments[i];
        }
    }
    return null;
}

Campaigns.New = function() {
    document.location.href = "campaign.aspx?id=-1";
}
Campaigns.Edit = function(id) {
    document.location.href = "campaign.aspx?id=" + id;
}
Campaigns.Save = function(data, callback) {
	try {
		console.info(data);
	} catch (e) {
	}
	callback();
}
Campaigns.Find = function(id) {
	for (var i=0,ii=campaigns.length;i<ii;i++) {
		if (campaigns[i].id == id) {
			return i;
		}
	}
	return -1;
}
Campaigns.Get = function(id) {
	var pos = Campaigns.Find(id);
	if (pos == -1) return null;
	else return campaigns[pos];
}
var Rule = function(rule) {
	this.data = rule;
	if (rule == null) {
		this.data = {ruleid:Math.random()};
		this.exists = false;
	} else this.exists = true;
}
Rule.prototype.GetTitle = function() {
	try {
		if (this.data.title != "") return this.data.title;
		else return Segments.Get(this.data.segmentid).data.title;
	} catch (e) {
		return "N/A";
	}
}
Rule.prototype.Pause = function() {
	this.data.status = "paused";
}
Rule.prototype.Resume = function() {
	this.data.status = "live";
}
var UIElement = function(uielement) {
	this.data = uielement;
	if (uielement == null) {
		this.data = {id:Math.random(), exists:false};
	} else this.data.exists = true;
}
UIElement.prototype.SetStatus = function(status) {
	this.data.status = status;
}
UIElement.prototype.LoadRules = function(rules) {
	this.rules = [];
	for (var i=0;i<rules.length;i++) {
		this.rules.push(Rules.Get(rules[i]));
	}
}
UIElement.prototype.GetRules = function(pageid) {
	this.rules = [];
	var i = rules.length;
	while (i--) {
		if (parseFloat(rules[i].ruleid) < 0) continue;
		if (typeof(pageid) == "undefined" ) {
			if (rules[i].uielementid == this.data.id) this.rules.push(rules[i]);
		} else {
			if (rules[i].uielementid == this.data.id && rules[i].pageid == pageid) this.rules.push(rules[i]);
		}
	}
	return this.rules;
}
UIElement.prototype.GetDefaultRule = function(pageid) {
	var i = rules.length;
	while (i--) {
		if (parseFloat(rules[i].ruleid) > 0) continue;
		if (typeof(pageid) == "undefined" ) {
			if (rules[i].uielementid == this.data.id) return rules[i];
		} else {
			if (rules[i].uielementid == this.data.id && rules[i].pageid == pageid) return rules[i];
		}
	}
	return null;
}
UIElement.prototype.GetPages = function() {
	var _rules = this.rules || this.GetRules();
	var obj = {};
	this.pages = [];
	for (var i=0;i<_rules.length;i++) {
		if (typeof(obj[_rules[i].pageid]) == "undefined") obj[_rules[i].pageid] = 0;
		obj[_rules[i].pageid] += 1;
	}
	for (var i in obj) {
		if (obj.hasOwnProperty(i)) this.pages.push({"id":i, "rules":obj[i]});
	}
	return this.pages;
}
UIElement.prototype.GetAllPages = function() {
	var p = [];
	for (var i=0;i<pages.length;i++) {
		for (var x=0;x<pages[i].uielements.length;x++) {
			if (pages[i].uielements[x].id == this.data.id) {
				p.push(new Page(pages[i]));
				break;
			}
		}
	}
	return p;
}
UIElement.prototype.GetStatus = function(page) {
	var i = page.data.uielements.length;
	while (i--) {
		if (page.data.uielements[i].id == this.data.id) return page.data.uielements[i].status;
	}
	return this.data.status;
}
var Page = function(page) {
	this.data = page;
	this.exists = (page != null);
	if (page == null) this.data = {id:Math.random(), uielements:[], exists:false};
}
Page.prototype.GetStatus = function(uiid) {
	if (typeof(uiid) == "undefined") return this.data.status;
	var i = this.data.uielements;
	while (i--) {
		if (this.data.uielements[i].id == uiid) return this.data.uielements[i].status;
	}
	var uielement = UIElements.Get(uiid);
	return uielement.data.status;
}
Page.prototype.GetRules = function(uiid) {
	this.rules = [];
	var i = rules.length;
	while (i--) {
		if (parseFloat(rules[i].ruleid) < 0) continue;
		if (typeof(uiid) == "undefined" ) {
			if (rules[i].pageid == this.data.id) this.rules.push(rules[i]);
		} else {
			if (rules[i].pageid == this.data.id && rules[i].uielementid == uiid) this.rules.push(rules[i]);
		}
	}
	return this.rules;
}
Page.prototype.GetUIElement = function(id) {
	var i = this.data.uielements.length;
	while (i--) {
		if (this.data.uielements[i].id == id) {
			var uielement = UIElements.Get(id);
			uielement.status = this.data.uielements[i].status;
			uielement.LoadRules(this.GetRules(id));
			return uielement;
		}
	}
	return new UIElement(null);
}
Page.prototype.GetUI = function(rules) {
	this.elements = [];
	var uielements = [];
	if (typeof(rules) != "undefined") {
		var obj = {};
		for (var i=0;i<rules.length;i++) {
			if (typeof(obj[rules[i].uielementid]) == "undefined") obj[rules[i].uielementid] = [];
			obj[rules[i].uielementid].push(rules[i].ruleid);
		}
		for (var i=0;i<this.data.uielements.length;i++) {
			if (typeof(obj[this.data.uielements[i].id]) != "undefined") {
				this.data.uielements[i].rules = obj[this.data.uielements[i].id];
				uielements.push(this.data.uielements[i]);
			}
		}
	} else uielements = this.data.uielements;

	for (var i=0;i<uielements.length;i++) {
		var UIElement = UIElements.Get(uielements[i].id);
		UIElement.status = uielements[i].status;
		
		if (typeof(uielements[i].rules) != "undefined") {
			UIElement.LoadRules(uielements[i].rules);
		}
		this.elements.push(UIElement);
	}
	return this.elements;
}
Page.prototype.Pause = function() {
	this.data.status = "paused";
}
Page.prototype.Resume = function() {
	this.data.status = "live";
}
Page.prototype.SetUIStatus = function(id, status) {
	var i = this.data.uielements.length;
	while (i--) {
		if (this.data.uielements[i].id == id) {
			this.data.uielements[i].status = status;
			break;
		}
	}
}
Page.prototype.DeleteUI = function(id) {
	var rules = this.GetRules(id);
	var x = rules.length;
	while (x--) Rules.Delete(rules[x].ruleid);
	
	var i = this.data.uielements.length;
	while (i--) {
		if (this.data.uielements[i].id == id) {
			this.data.uielements.splice(i, 1);
			break;
		}
	}
}

var Goals = {};
Goals.Get = function(id, obj) {
	var i = goals.length;
	while (i--) {
		if (goals[i].id == id) return goals[i];
	}
	return null;
}
var Pages = {};
Pages.Get = function(id, obj) {
	var i = pages.length;
	while (i--) {
		if (pages[i].id == id) return new Page(pages[i]);
	}
	if (typeof(obj) != "undefined") {
		var page = {"id":obj.id, "title":obj.name, "url":obj.url, "status":"live", "uielements":[]};
		pages.push(page);
		return new Page(page);
	} else return new Page(null);
}
Pages.Delete = function(id) {
	var i = pages.length;
	while (i--) {
		if (pages[i].id == id) {
			var page = new Page(pages[i]);
			var rules = page.GetRules();
			var x = rules.length;
			while (x--) Rules.Delete(rules[x].ruleid);
//			pages.splice(i, 1);
		}
	}
}

var UIElements = {};
UIElements.Get = function(id) {
	var i = uielements.length;
	while (i--) {
		if (uielements[i].id == id) return new UIElement(uielements[i]);
	} 
	return new UIElement(null);
}
UIElements.Delete = function(id) {
	var i = uielements.length;
	while (i--) {
		if (uielements[i].id == id) {
			uielements.splice(i, 1);
			break;
		}
	}
	var i = pages.length;
	while (i--) {
		var page = new Page(pages[i]);
		page.DeleteUI(id);
	}
}

var Rules = {};
Rules.Find = function(pageid, uiid, segmentid) {
	var i = rules.length;
	while (i--) {
		if (rules[i].pageid == pageid && rules[i].uielementid == uiid && rules[i].segmentid == segmentid) return new Rule(rules[i]);
	}
	return new Rule(null);
}
Rules.Get = function(id) {
	var i = rules.length;
	while (i--) {
		if (rules[i].ruleid == id) return new Rule(rules[i]);
	}
	return new Rule(null);
}
Rules.Delete = function(id) {
	var i = rules.length;
	while (i--) {
		if (rules[i].ruleid == id) {
			rules.splice(i, 1);
			break;
		}
	}
}
Rules.SetStatus = function(id, status) {
	var i = rules.length;
	while (i--) {
		if (rules[i].ruleid == id) {
			rules[i].status = status;
			break;
		}
	}
}
Rules.Update = function(id, title, value) {
	var i = rules.length;
	while (i--) {
		if (rules[i].ruleid == id) {
			rules[i].title = (Segments.Get(rules[i].segmentid).data.title != title) ? title : "";
			rules[i].value = value;
			break;
		}
	}
}
var ServerDelay = 500;
var Server = {};
Server.Store = function(data, callback) {
	var id = Math.random()*1000000;
	$.ajax({
		type: 'POST',
		url: "/CardioLog/MarketingSuite/Assets/Scripts/Store.aspx?id="+id,
		data: escape(escape(data)),
		success: function(status) { callback(id); }
	});
}
Server.Retrieve = function(id, callback) {
	$.ajax({
		url: "/CardioLog/MarketingSuite/Assets/Scripts/Retrieve.aspx?id="+id,
		context: document.body,
		success: callback
	});
}

Server.ParseResponse = function(response) {
	if (response.match(/dataError/) == null) return {"code":0, "description":"OK", "value":response};
	else if (response.match(/^var /) != null) {
		try {
			eval(response.replace(/[\n\r]/g, " "));
			if (typeof(dataError) != "undefined") return {"code":-1, "description":dataError};
		} catch (e) {
			alert(e.message);
		}
	} else return {"code":-1, "description":response}
}
Server.Call = function(url, params, callback, method) {
	method = method || "GET";

	var parameters = [];
	for (var i in params) {
		if (params.hasOwnProperty(i)) parameters.push(i+"="+((typeof(params[i]) == "string") ? escape(params[i]) : params[i]));
	}
	
	if (method == "GET") {
		url += (url.match(/\?/) ? "&" : "?")+parameters.join("&")+"&_random="+Math.random();
		window.setTimeout(function() {
			$.ajax({
				url: url,
				context: document.body,
				success: function(status) { callback(Server.ParseResponse(status)); }
			});
		}, ServerDelay);
	} else {
		window.setTimeout(function() {
			$.ajax({
				url: url,
				data: parameters.join("&"),
				type: 'POST',
				context: document.body,
				success: function(status) { callback(Server.ParseResponse(status)); }
			});
		}, ServerDelay);
	}
}
/*Server.DeleteSurvey = function(id, callback) {
	$.ajax({
			url: '/CardioLog/MarketingSuite/VoiceOfCustomer/handlers/delete.ashx?r='+Math.random(),
			data: { surveyID: id },
			type: 'POST',
			context: this,
			success: callback
	});
}*/

// Detach and keep is not used anymore, so removing it should be considered.
Server.SEO = {};
Server.SEO.SaveSettings = function(useragent, maxrequests, reportsdirectory, excludeurls, ignorewords, wordseparator, externalprogram, commandline,iswebsitetreejob, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", { "action": "editseosettings", "useragent": useragent, "maxrequests": maxrequests, "reportsdirectory": reportsdirectory, "excludeurls": excludeurls, "ignorewords": ignorewords, "wordseparator": wordseparator, "externalprogram": externalprogram, "commandline": commandline, "iswebsitetreejob": iswebsitetreejob }, callback);
}
Server.SEO.SaveJob = function (id, name, schedule, scheduledetails, starturl, maxno, maxdownload, ignorenofollow, ignorenoindex, storecopies, extlink, auth, username, password, iswebsitetreejob, callback)
{
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", { "action": "editseojob", "id": id, "title": name, "scheduletype": schedule, "miliseconds": scheduledetails, "starturl": starturl, "maxurls": maxno, "maxdownloadsizekb": maxdownload, "ignorenofollow": ignorenofollow, "ignorenoindex": ignorenoindex, "storepageslocaly": storecopies, "internallinkstype": extlink, "authtype": auth, "authuser": username, "authpassword": password, "iswebsitetreejob": iswebsitetreejob }, callback);
}
Server.SEO.DeleteSharepointFarmSettings = function (id, detachandkeep, callback) {
    Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", { "action": "deletesharepointfarm", "id": id, "detachandkeep": detachandkeep }, callback);
}
Server.SEO.DeleteJob = function(id, iswebsitetreejob, detachandkeep, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", { "action": "deleteseojob", "id": id, "iswebsitetreejob": iswebsitetreejob, "detachandkeep": detachandkeep }, callback);
}
Server.SEO.RunJob = function(id, iswebsitetreejob, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", { "action": "runseojob", "id": id, "iswebsitetreejob": iswebsitetreejob }, callback);
}
Server.SaveTracker = function(campaignid, linkid, url, pageurl, term, content, callback) {
	Server.Call("/CardioLog/MarketingSuite/Campaigns/data.aspx", {"action":"editTrackingLink", "campaignId":campaignid, "url":url, "pageUrl":pageurl, "term":term, "content":content, "linkId":(linkid ? linkid : null)}, callback);
}
Server.CreateShortenLink = function(campaignid, pageurl, callback) {
	Server.Call("/CardioLog/MarketingSuite/Campaigns/data.aspx", {"action":"createShortenLink", "campaignId":campaignid, "pageUrl":pageurl}, callback);
}
Server.CreateShortenCampaign = function(username, callback) {
	Server.SaveCampaign("-1", "Shorten Links - "+username, "shortenlinks", username, username, callback);
}
Server.SaveCampaign = function (id, name, medium, source, username, callback) {
	Server.Call("/CardioLog/MarketingSuite/Campaigns/data.aspx", {"action":"editCampaign", "username":username, "hidden":false, "name":name, "medium":medium, "source":source, "campaignId":((id != "-1") ? id : "")}, callback);
}
Server.HideCampaign = function(id, callback) {
	window.setTimeout(function() {
		$.ajax({
		  url: "/CardioLog/MarketingSuite/Campaigns/data.aspx?"+"action=hideCampaign&campaignId="+id,
		  context: document.body,
		  success: callback
		});
	}, ServerDelay);
}
Server.DeleteTracker = function(id, callback) {
	window.setTimeout(function() {
		$.ajax({
		  url: "/CardioLog/MarketingSuite/Campaigns/data.aspx?"+"action=deleteTrackingLink&linkId="+id,
		  context: document.body,
		  success: callback
		});
	}, ServerDelay);
}
Server.SavePixel = function(campaignid, pixelid, goal, url, conversiontag, callback) {
	if (pixelid != "")
		Server.Call("/CardioLog/MarketingSuite/Campaigns/data.aspx", {"action":"editPixel", "pixelId":pixelid,"campaignId":campaignid, "goalId":goal, "conversionTag":conversiontag, "url":url}, callback);
	else
		Server.Call("/CardioLog/MarketingSuite/Campaigns/data.aspx", {"action":"editPixel", "campaignId":campaignid, "goalId":goal, "conversionTag":conversiontag, "url":url}, callback);
}

Server.DeletePixel = function(id, callback) {
	window.setTimeout(function() {
		$.ajax({
		  url: "/CardioLog/MarketingSuite/Campaigns/data.aspx?"+"action=deletePixel&pixelId="+id,
		  context: document.body,
		  success: callback
		});
	}, ServerDelay);
}
Server.GenerateURL = function(callback) {
	Server.Call("/CardioLog/MarketingSuite/Campaigns/data.aspx", {"action":"generateURL"}, callback);
}
Server.CheckAvailability = function(url, callback) {
	Server.Call("/CardioLog/MarketingSuite/Campaigns/data.aspx", {"action":"checkAvailability", "url":url}, callback);
}
Server.SaveToolbar = function(id, status, urlpattern, segmentid, content, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data_toolbars.aspx", {"action":"edittoolbar", "toolbarId":id, "status":status, "urlpattern":urlpattern, "segmentid":segmentid, "content":content}, callback, "POST");
}
Server.GetToolbar = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data_toolbars.aspx", {"action":"gettoolbar", "toolbarId":id}, callback);
}
Server.DeleteToolbar = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_toolbars.aspx", {"action":"deletetoolbar", "toolbarId":id}, callback);
}
Server.FlushToolbar = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_toolbars.aspx", {"action":"flushtoolbar", "toolbarId":id}, callback);
}
Server.SaveSurvey = function(id, status, urlpattern, segmentid, content, questions, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data_voc.aspx", {"action":"editsurvey", "surveyId":id, "status":status, "urlpattern":urlpattern, "segmentid":segmentid, "content":encodeURIComponent(content), "questions":encodeURIComponent(questions)}, callback, "POST");
	// /CardioLog/MarketingSuite/Assets/Scripts/

	//http://holland:8081/CardioLog/MarketingSuite/VoiceOfCustomer/Assets/scripts/interface.aspx?action=editsurvey&surveyId=-1&status=2&content={'title':'survey%20number%201'}
}
Server.GetSurvey = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data_voc.aspx", {"action":"getsurvey", "surveyId":id}, callback);
	// Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_voc.aspx", {"action":"getsurvey", "surveyId":id}, callback);
}
Server.GetSurveyResults = function(id, url, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_voc.aspx", {"action":"getfullresults", "pageURL": url, "surveyId":id}, callback);
}
Server.GetSurveyResultsPages = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_voc.aspx", {"action":"getpageurls", "surveyId":id}, callback);
}
Server.GetMoreAnswers = function(id, maxdate, url, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_voc.aspx", {"action":"getopenanswers", "questionId":id, "pageURL":url, "numOfRows":100, "maxDate":maxdate}, callback);
}
Server.GetExplanations = function(question, answer, maxdate, url, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_voc.aspx", {"action":"getanswerdescriptions", "questionId":question, "pageURL":url, "answerValue":answer, "numOfRows":100, "maxDate":maxdate}, callback);
}
Server.SaveSegment = function(id, title, type, definitions, callback) {
	if (id == "-1") Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"editsegment", "title":title, "type":type, "definition":definitions}, callback);
	else Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"editsegment", "title":title, "type":type, "definition":definitions, "id":id}, callback);
}
Server.UpdateAtlasMediaPlansSegmentId = function(type, segmentid, ids, callback) {
	// http://holland:8081/CardioLog/MarketingSuite/Campaigns/data.aspx?action=updateAtlasMediaPlansSegmentId&type=mediaplan&segment_id=1&ids=2,4&username=atlas
	Server.Call("/CardioLog/MarketingSuite/Campaigns/data.aspx", {"action":"updateAtlasMediaPlansSegmentId", "type":type, "segment_id":segmentid, "ids": ids.join(","), "username":"atlas"}, callback);
}
Server.DeleteSurvey = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_voc.aspx", {"action":"deletesurvey", "surveyId":id}, callback);
	// Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_voc.aspx", {"action":"deletesurvey", "surveyId":id}, callback);
}
Server.FlushSurvey = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_voc.aspx", {"action":"clearsurvey", "surveyId":id}, callback);
	// Server.Call("/CardioLog/MarketingSuite/Assets/scripts/data_voc.aspx", {"action":"deletesurvey", "surveyId":id}, callback);
}
Server.DeleteSegment = function(id, callback) {
	window.setTimeout(function() {
		$.ajax({
		  url: "/CardioLog/MarketingSuite/Assets/Scripts/data.aspx?"+"action=deletesegment&id="+id,
		  context: document.body,
		  success: callback
		}); 
	}, ServerDelay);
}
Server.AddPersonalizedContent = function(pageid, uielementid, segmentid, value, title, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"addpersonalizedcontent", "pageid":pageid, "uielementid":uielementid, "segmentId":segmentid, "value":value, "title":title}, callback, "POST");
}
Server.UpdateUIElement = function(uielementid, value, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"updateuielement", "uiid":uielementid, "value":value}, callback, "POST");
}
Server.EditPersonalizedContent = function(ruleid, title, value, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"editpersonalizedcontent", "ruleid":ruleid, "value":value, "title":title}, callback, "POST");
}
Server.DeletePage = function(pageid, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"deletepage", "pageid":pageid}, callback);
}
Server.PausePage = function(pageid, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"pausepage", "pageid":pageid}, callback);
}
Server.ResumePage = function(pageid, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"resumepage", "pageid":pageid}, callback);
}
Server.DeleteUI = function(uiid, pageid, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"deleteui", "uiid":uiid}, callback);
}
Server.PauseUI = function(uiid, pageid, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"pauseui", "uiid":uiid}, callback);
}
Server.ResumeUI = function(uiid, pageid, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"resumeui", "uiid":uiid}, callback);
}
Server.PauseRule = function(ruleid, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"pauserule", "ruleid":ruleid}, callback);
}
Server.ResumeRule = function(ruleid, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"resumerule", "ruleid":ruleid}, callback);
}
Server.DeleteRule = function(ruleid, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"deleteRule", "ruleid":ruleid}, callback);
}
Server.CreateUIElement = function(pageid, htmlpath, htmlid, title, type, value, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", { "action": "adduielement", "id": pageid, "htmlpath": htmlpath.replace(/ /g, "%20"), "htmlid": htmlid, "title": title, "value": value, "type": type }, callback, "POST");
}
Server.AddUIElementToPage = function(uielementid, pageid, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", { "action": "adduielementtopage", "id": pageid, "uiid": uielementid }, callback, "POST");
}
Server.PauseTest = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Optimization/Assets/Scripts/data.aspx", {"action":"pausetest", "id":id}, callback);
}
Server.FlushTest = function (id, callback) {
    Server.Call("/CardioLog/MarketingSuite/Optimization/Assets/Scripts/data.aspx", { "action": "flushtest", "testid": id }, callback);
}
Server.DeleteTest = function (id, callback) {
    Server.Call("/CardioLog/MarketingSuite/Optimization/Assets/Scripts/data.aspx", { "action": "deletetest", "id": id }, callback);
}
Server.ResumeTest = function (id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Optimization/Assets/Scripts/data.aspx", {"action":"resumetest", "id":id}, callback);
}
Server.StopTest = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Optimization/Assets/Scripts/data.aspx", {"action":"endtest", "id":id}, callback);
}
Server.StartTest = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Optimization/Assets/Scripts/data.aspx", {"action":"resumetest", "id":id}, callback);
}
Server.CopyTest = function(id, callback) {
	Server.Call("/CardioLog/MarketingSuite/Assets/Scripts/data.aspx", {"action":"copytest", "testid":id}, callback);
}
Server.SaveTest = function (id, type, name, pageurl, notes, segment, percentage, variations, callback) {
    switch (type) {
        case "split":
            Server.Call("/CardioLog/MarketingSuite/Optimization/Assets/Scripts/data.aspx", { "action": "editsplittest", "id": id, "title": name, "notes": notes, "percentage": percentage, "status": "paused", "segmentid": segment, "pageUrl": pageurl.replace(/ /g, "%20"), "variations": variations }, callback, "POST");
            break;
        case "AB":
        	Server.Call("/CardioLog/MarketingSuite/Optimization/Assets/Scripts/data.aspx", { "action": "editabtest", "type_id": 1, "id": id, "title": name, "notes": notes, "percentage": percentage, "status": "paused", "segmentid": segment, "pageUrl": pageurl.replace(/ /g, "%20"), "variations": variations }, callback, "POST");
            break;
        case "MVT":
        	Server.Call("/CardioLog/MarketingSuite/Optimization/Assets/Scripts/data.aspx", { "action": "editmvttest", "id": id, "title": name, "notes": notes, "percentage": percentage, "status": "paused", "segmentid": segment, "pageUrl": pageurl.replace(/ /g, "%20"), "combinations": variations }, callback, "POST");
            break;
    }
}
var Content = {};
Content.Add = function (data) {
	Loader.show("Saving personalized content...", true);
	function callback(status) {
		Loader.hide();
		if (status) {
			if (data.id != "-1") {
			} else {
				var page = Pages.Get(data.page.id, data.page);
				rules.push({ "ruleid": Math.round(Math.random() * 10000), "status":"live", "pageid": page.data.id, "uielementid": data.uielement, "segmentid": data.segment, "value": data.value, "title": data.title });
			}
		} else Loader.show("Error saving personalized content");
		
		if (data.shouldreload) executecommand("createui");
		else drawcontent(groupby);
	}
	if (data.id != "-1") {
		Server.EditPersonalizedContent(data.id, data.title, data.value, callback);
	} else {
		Server.AddPersonalizedContent(data.page.id, data.uielement, data.segment, data.value, data.title, callback);
	}
}
Content.CancelAdd = function(data) {
	if (data.shouldreload) executecommand("createui");
}
Content.New = function (uiid, pageid, segmentid) {
	var myJSONObject = {"popupArguments":[{pageid:pageid, uiid:uiid, segmentid:segmentid, title:"New Personalized Content", href:"/CardioLog/MarketingSuite/BehavioralTargeting/content.aspx", callback:Content.Add, cancelcallback:Content.CancelAdd, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/content.aspx", 426, 700, myJSONObject);
}
Content.Edit = function(data) {
	Loader.show("Saving personalized content...", true);
	function callback(status) {
		Loader.hide();
		if (status) { 	
			if (parseFloat(data.id) < 0) {
				var uielement = UIElements.Get(data.uielement);
				uielement.defaultvalue = data.value;
			} else {
				Rules.Update(data.id, data.title, data.value);
			}
		} else Loader.show("Error saving personalized content");
		drawcontent(groupby);
	}
	if (parseFloat(data.id) < 0) {
		Server.UpdateUIElement(data.uielement, data.value, callback);
	} else {
		Server.EditPersonalizedContent(data.id, data.title, data.value, callback);
	}
}
Content.OpenEdit = function(id) {
	var rule = Rules.Get(id);
	var myJSONObject = {"popupArguments":[{pageid:rule.data.pageid, uiid:rule.data.uielementid, segmentid:rule.data.segmentid, rule:rule, title:"Edit Personalized Content", href:"/CardioLog/MarketingSuite/BehavioralTargeting/content.aspx", callback:Content.Edit, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/content.aspx", 426, 700, myJSONObject);
}
Content.DeletePage = function(id) {
	Loader.show("Deleting page...", true);
	function callback(status) {
		Loader.hide();
		if (status) Pages.Delete(id);
		else Loader.show("Error deleting page");
		drawcontent(groupby);
	}
	Server.DeletePage(id, callback);
}
Content.ConfirmDeletePage = function(id) {
	var page = Pages.Get(id);
	var myJSONObject = {"popupArguments":[{page:page, href:"/CardioLog/MarketingSuite/BehavioralTargeting/delete-page.aspx", callback:Content.DeletePage, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/delete-page.aspx", 171, 700, myJSONObject);
}
Content.PauseSegment = function(id) {
	Loader.show("Pausing personalized content on this segment...", true);
	function callback(status) {
		Loader.hide();
		if (status) Segments.Get(id).Pause();
		else Loader.show("Error pausing segment");
		drawcontent(groupby);
	}
	Server.PauseSegment(id, callback);
}
Content.ConfirmPauseSegment = function(id, callback) {
	var segment = Segments.Get(id);
	var myJSONObject = {"popupArguments":[{segment:segment, href:"/CardioLog/MarketingSuite/BehavioralTargeting/pause-segment.aspx", callback:Content.PauseSegment, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/pause-segment.aspx", 171, 700, myJSONObject);
}
Content.PausePage = function(id) {
	Loader.show("Pausing personalized content on this page...", true);
	function callback(status) {
		Loader.hide();
		if (status) Pages.Get(id).Pause();
		else Loader.show("Error pausing page");
		drawcontent(groupby);
	}
	Server.PausePage(id, callback);
}
Content.ConfirmPausePage = function(id) {
	var page = Pages.Get(id);
	var myJSONObject = {"popupArguments":[{page:page, href:"/CardioLog/MarketingSuite/BehavioralTargeting/pause-page.aspx", callback:Content.PausePage, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/pause-page.aspx", 171, 700, myJSONObject);
}
Content.ResumePage = function(id) {
	Loader.show("Resuming personalized content on this page...", true);
	function callback(status) {
		Loader.hide();
		if (status) Pages.Get(id).Resume();
		else Loader.show("Error resuming page");
		drawcontent(groupby);
	}
	Server.ResumePage(id, callback);
}
Content.ConfirmResumePage = function(id) {
	var page = Pages.Get(id);
	var myJSONObject = {"popupArguments":[{page:page, href:"/CardioLog/MarketingSuite/BehavioralTargeting/resume-page.aspx", callback:Content.ResumePage, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/resume-page.aspx", 171, 700, myJSONObject);
}
Content.DeleteUI = function(uiid, pageid) {
	Loader.show("Deleting UI element...", true);
	function callback(status) {
		Loader.hide();
		if (status) {
			if (pageid != null) Pages.Get(pageid).DeleteUI(uiid);
			else UIElements.Delete(uiid);
		} else Loader.show("Error deleting UI element");
		drawcontent(groupby);
	}
	Server.DeleteUI(uiid, pageid, callback);
}
Content.ConfirmDeleteUI = function(uiid, pageid) {
	var page, ui;
	if (typeof(pageid) != "undefined") {
		page = Pages.Get(pageid);
		ui = page.GetUIElement(uiid);
	} else {
		ui = UIElements.Get(uiid);
		ui.GetRules();
	}
	var myJSONObject = {"popupArguments":[{page:page, ui:ui, href:"/CardioLog/MarketingSuite/BehavioralTargeting/delete-ui.aspx", callback:Content.DeleteUI, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/delete-ui.aspx", 171, 700, myJSONObject);
}
Content.PauseUI = function(uiid, pageid) {
	Loader.show("Pausing UI element...", true);
	function callback(status) {
		Loader.hide();
		if (status) {
			if (pageid != null) Pages.Get(pageid).SetUIStatus(uiid, "paused");
			else UIElements.Get(uiid).SetStatus("paused");
		} else Loader.show("Error pausing UI element");
		drawcontent(groupby);
	}
	Server.PauseUI(uiid, pageid, callback);
}
Content.ConfirmPauseUI = function(uiid, pageid) {
	var page, ui;
	if (typeof(pageid) != "undefined") {
		page = Pages.Get(pageid);
		ui = page.GetUIElement(uiid);
	} else {
		ui = UIElements.Get(uiid);
		ui.GetRules();
	}
	var myJSONObject = {"popupArguments":[{page:page, ui:ui, href:"/CardioLog/MarketingSuite/BehavioralTargeting/pause-ui.aspx", callback:Content.PauseUI, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/pause-ui.aspx", 171, 700, myJSONObject);
}
Content.ResumeUI = function(uiid, pageid) {
	Loader.show("Resuming UI element...", true);
	function callback(status) {
		Loader.hide();
		if (status) {
			if (pageid != null) Pages.Get(pageid).SetUIStatus(uiid, "live");
			else UIElements.Get(uiid).SetStatus("live");
		} else Loader.show("Error resuming UI element");
		drawcontent(groupby);
	}
	Server.ResumeUI(uiid, pageid, callback);
}
Content.ConfirmResumeUI = function(uiid, pageid) {
	var page, ui;
	if (typeof(pageid) != "undefined") {
		page = Pages.Get(pageid);
		ui = page.GetUIElement(uiid);
	} else {
		ui = UIElements.Get(uiid);
		ui.GetRules();
	}
	var myJSONObject = {"popupArguments":[{page:page, ui:ui, href:"/CardioLog/MarketingSuite/BehavioralTargeting/resume-ui.aspx", callback:Content.ResumeUI, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/resume-ui.aspx", 171, 700, myJSONObject);
}
Content.PauseRule = function(id) {
	Loader.show("Pausing rule...", true);
	function callback(status) {
		Loader.hide();
		if (status) Rules.Get(id).Pause();
		else Loader.show("Error pausing rule");
		drawcontent(groupby);
	}
	Server.PauseRule(id, callback);
}
Content.ConfirmPauseRule = function(id) {
	var myJSONObject = {"popupArguments":[{rule:Rules.Get(id), href:"/CardioLog/MarketingSuite/BehavioralTargeting/pause-rule.aspx", callback:Content.PauseRule, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/pause-rule.aspx", 171, 700, myJSONObject);
}
Content.ResumeRule = function(id) {
	Loader.show("Resuming UI element...", true);
	function callback(status) {
		Loader.hide();
		if (status) Rules.Get(id).Resume();
		else Loader.show("Error resuming rule");
		drawcontent(groupby);
	}
	Server.ResumeRule(id, callback);
}
Content.ConfirmResumeRule = function(id) {
	var myJSONObject = {"popupArguments":[{rule:Rules.Get(id), href:"/CardioLog/MarketingSuite/BehavioralTargeting/resume-rule.aspx", callback:Content.ResumeRule, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/resume-rule.aspx", 171, 700, myJSONObject);
}
Content.DeleteRule = function(id) {
	Loader.show("Deleting UI element...", true);
	function callback(status) {
		Loader.hide();
		if (status) Rules.Delete(id);
		else Loader.show("Error deleting rule");
		drawcontent(groupby);
	} 
	Server.DeleteRule(id, callback);
}
Content.ConfirmDeleteRule = function(id) {
	var myJSONObject = {"popupArguments":[{rule:Rules.Get(id), href:"/CardioLog/MarketingSuite/BehavioralTargeting/delete-rule.aspx", callback:Content.DeleteRule, self:top}]};
	parent.PopupManager.ShowPopup("/CardioLog/MarketingSuite/BehavioralTargeting/delete-rule.aspx", 171, 700, myJSONObject);
}
Content.FlushTest = function (id) {
    Loader.show("Deleting test results...", true);
    function callback(status) {
        if (status.code == 0) {
					Loader.show("Test results were deleted successfully", false, 1000);
        	Tests.Get(id).Pause();
        } else Loader.show("Error deleting test results: "+status.description, false, 2000);
        drawtest();
    }
    Server.FlushTest(id, callback);
}
Content.DeleteTest = function (id) {
    Loader.show("Deleting test...", true);
    function callback(status) {
        if (status.code == 0) Loader.showonnextpage("index.aspx", "Test deleted successfully", 1000);
        else Loader.show("Error deleting test: "+status.description);
        drawtest();
    }
    Server.DeleteTest(id, callback);
}
Content.PauseTest = function(id) {
	Loader.show("Pausing test...", true);
	function callback(status) {
		if (status.code == 0) {
			Loader.show("Test paused successfully", false, 1000);
			Tests.Get(id).Pause();
		} else Loader.show("Error pausing test: "+status.description, false, 2000);
		drawtest();
	}
	Server.PauseTest(id, callback);
}
Content.ResumeTest = function(id) {
	Loader.show("Resuming test...", true);
	function callback(status) {
		if (status.code == 0) {
			Loader.show("Test resumed successfully", false, 1000);
			Tests.Get(id).Resume();
		} else Loader.show("Error resuming test: "+status.description, false, 2000);
		drawtest();
	}
	Server.ResumeTest(id, callback);
}
Content.StopTest = function (id)
{
	Loader.show("Stopping test...", true);
	function callback(status)
	{
		if (status.code == 0) {
			Loader.showonnextpage("index.aspx?filter=ended", "Test stopped successfully", 1000);
			Tests.Get(id).Stop();
		} else Loader.show("Error stopping test: " + status.description, false, 2000);
		drawtest();
	}
	Server.StopTest(id, callback);
}
Content.StartTest = function(id) {
	Loader.show("Starting test...", true);
	function callback(status) {
		if (status.code == 0) {
			Loader.show("Test stated successfully", false, 1000);
			Tests.Get(id).Start();
		} else Loader.show("Error starting test: "+status.description, false, 2000);
		drawtest();
	}
	Server.StartTest(id, callback);
}
Content.FindRulePosition = function(ruleid) {
	for (var i=0;i<rules.length;i++) {
		if (rules[i].ruleid == ruleid) return i;
	} 
	return -1;
}
Content.FindPagePosition = function(id) {
	for (var i=0;i<pages.length;i++) {
		if (pages[i].id == id) return i;
	}
	return -1;
}
Content.FindUIElementPosition = function(id) {
	for (var i=0;i<uielements.length;i++) {
		if (uielements[i].id == id) return i;
	} 
	return -1;
}
Content.GetUIElement = function(id) {
	var pos = Content.FindUIElementPosition(id);
	if (pos == -1) return null;
	else return uielements[pos];
}
Content.GetPage = function(id) {
	var pos = Content.FindPagePosition(id);
	return (pos == -1) ? null : pages[pos];
}
Content.GetUIElementsByPage = function(pagerules) {
	var obj = {};
	for (var i=0;i<pagerules.length;i++) {
		var pos = Content.FindRulePosition(pagerules[i]);
		if (pos != -1) {
			if (typeof(obj[rules[pos].uielementid]) == "undefined") obj[rules[pos].uielementid] = 0;
			obj[rules[pos].uielementid] += 1;
		}
	}
	var arr = [];
	for (var i in obj) {
		if (obj.hasOwnProperty(i)) arr.push({"id":i, "rules":obj[i]});
	}
	return arr;
}
Content.GetRulesByUIElementsAndPage = function(uielementid, pageid) {
	var arr = [];
	for (var i=0;i<rules.length;i++) {
		if (rules[i].uielementid == uielementid && rules[i].pageid == pageid) {
			arr.push(rules[i]);
		}
	}
	return arr;
}
Content.GetRulesByUIElement = function(uielementid) {
	var arr = [];
	for (var i=0;i<rules.length;i++) {
		if (rules[i].uielementid == uielementid) arr.push(rules[i].ruleid);
	}
	return arr;
}
Content.GetSegmentsByPage = function(pageid) {
	var arr = [];
	for (var i=0;i<rules.length;i++) {
		if (rules[i].pageid == pageid) arr.push(rules[i].segmentid);
	}
	return arr;
}
Content.FillDefaultSegment = function() {
	for (var p=0;p<pages.length;p++) {
		for (var u=0;u<pages[p].uielements.length;u++) {
			var uielement = UIElements.Get(pages[p].uielements[u].id);
			rules.push({"ruleid":-Math.random(), "title":"", "status":"live", "pageid":pages[p].id, "uielementid":pages[p].uielements[u].id, "segmentid":"-1", "value":uielement.defaultvalue});
//var rules = [{"ruleid":2,"title":"kkk","status":"live","pageid":"5e2a53a9-b719-4d31-93bf-e4331dd6ea61","uielementid":1,"segmentid":1,"value":"Text for kkk"}];
		}
	}
}
Content.GetPagesByUIElements = function(uielementid) {
	var _rules = Content.GetRulesByUIElement(uielementid);
	var obj = {};
	var arr = [];
	for (var i=0;i<_rules.length;i++) {
		var pos = Content.FindRulePosition(_rules[i]);
		if (pos != -1) {
			if (typeof(obj[rules[pos].pageid]) == "undefined") obj[rules[pos].pageid] = 0;
			obj[rules[pos].pageid] += 1;
		}
	}
	for (var i in obj) {
		if (obj.hasOwnProperty(i)) arr.push({"id":i, "rules":obj[i]});
	}
	return arr;
}
Content.GetRulesBySegment = function(segmentid) {
	var arr = [];
	for (var i=0;i<rules.length;i++) {
		if (rules[i].segmentid == segmentid) arr.push(rules[i].ruleid);
	}
	return arr;
}
Content.GetPagesBySegments = function(id) {
	var _rules = Content.GetRulesBySegment(id);
	var obj = {};
	var arr = [];
	for (var i=0;i<_rules.length;i++) {
		var pos = Content.FindRulePosition(_rules[i]);
		if (pos != -1) {
			if (typeof(obj[rules[pos].pageid]) == "undefined") obj[rules[pos].pageid] = 0;
			obj[rules[pos].pageid] += 1;
		}
	}
	for (var i in obj) {
		if (obj.hasOwnProperty(i)) arr.push({"id":i, "rules":obj[i]});
	}
	return arr;
}
Content.GetUIElementsBySegmentAndPage = function(segmentid, pageid) {
	var arr = [];
	for (var i=0;i<rules.length;i++) {
		if (rules[i].segmentid == segmentid && rules[i].pageid == pageid) {
			var pos = Content.FindUIElementPosition(rules[i].uielementid);
			if (pos != -1) arr.push(uielements[pos]);
		}
	}
	return arr;
	
}

function Affiliate(data) {
	this.data = data;
	this.exists = (data == null) ? false : true;
}
Affiliate.prototype.GetStatus = function() {
	if (this.data.clicks == 0 || formattimestamptohours(this.data.lastClickDate) > 3) return "inactive";
	else return "active";
}

function Messagebar(data) {
	this.data = data;
	if (data == null) this.data = {id:Math.random()};
	else if (typeof(data.content) == "string") eval("this.content = "+data.content);
	else this.content = data.content;

	if (typeof(this.data.views) == "undefined") this.data.views = 0;
	if (typeof(this.data.clicks) == "undefined") this.data.clicks = 0;
}
Messagebar.prototype.GetTitle = function() {
	return this.content.name;
}
Messagebar.prototype.GetStatus = function() {
	if (this.data.status == 1) return "<span class='active'>Active</span>";
	else if (this.data.status == 2) return "<span class='inactive'>Inactive</span>";
	else return "<span>"+this.data.status+"</span>";
}
Messagebar.prototype.MatchStatus = function(value, segmentid) {
	if (value == "all") return true;
	else if (value == this.data.status) return true;

	if (value == 5) {
		if (typeof(segmentid) == "undefined" || segmentid == null) return true;
		else if (this.data.segmentid == segmentid) return true;
		else return false;
	}
	
	return false;
}
	
function Survey(data) {
	this.data = data;
	if (data == null) this.data = {id:Math.random()};
	else this.content = data.content;
	
	if (typeof(this.data.views) == "undefined") this.data.views = 0;
	if (typeof(this.data.responses) == "undefined") this.data.responses = 0;
}
Survey.prototype.GetTitle = function() {
	return this.content.title;
}
Survey.prototype.GetStatus = function() {
	if (this.data.status == 1) return "<span class='active'>Active</span>";
	else if (this.data.status == 2) return "<span class='inactive'>Inactive</span>";
	else return "<span>"+this.data.status+"</span>";
}
Survey.prototype.MatchStatus = function(value, segmentid) {
	if (value == "all") return true;
	else if (value == this.data.status) return true;

	if (value == 3) {
		// surveys that segmentid is not -1
		if (this.data.segmentid != -1) return true;
	} else if (value == 4) {
		// surveys that segmentid is -1
		if (this.data.segmentid == -1) return true;
	} else if (value == 5) {
		if (typeof(segmentid) == "undefined" || segmentid == null) return true;
		else if (this.data.segmentid == segmentid) return true;
		else return false;
	}
	
	return false;
}
function Segment(data) {
	this.data = data;
	if (data == null) this.data = {id:Math.random()};
	this.type = "lifetime";
	this.score = 0;
	for (var i=0;i<this.data.definition.length;i++) {
		if (this.data.definition[i].n == "score") {
			this.score = parseInt(this.data.definition[i].v, 10);
			if (isNaN(this.score)) this.score = 0;
		}
		if (this.data.definition[i].n == "stype") {
			this.type = this.data.definition[i].v;
		}
	}
}
Segment.prototype.GetTitle = function() {
	return this.data.title.replace(/^(Atlas|Campaign|Tracking Link):[ ]*/, "");
}
Segment.prototype.MatchStatus = function(value) {
	if (value == "all") return true;
	else if (value == "score" && this.score > 0) return true;
	else if (value == "session" && this.type == "session") return true;
	else if (value == "lifetime" && this.type == "lifetime") return true;
	else if (value == "page" && this.type == "page") return true;
	else if (value == "atlas" && this.data.title.match(/^Atlas/)) return true;
	else if (value == "campaigns" && this.data.title.match(/^(Campaign|Tracking Link)/)) return true;
	return false;
}
function Campaign(data) {
	this.data = data;
}
Campaign.prototype.GetStatus = function() {
	if (this.data.clicks == 0 || formattimestamptohours(this.data.lastClickDate) > 72) return "inactive";
	else return "active";
}
var PopupManager = {};
PopupManager.Show = function(url, data, props) {
	PopupManager.arguments = data;
	var newwindow = window.open(url, "newWindow", props);
}
window["PopupManager"] = PopupManager;

function getparam(name) {
	var re = new RegExp("(?:\\?|\\&)"+name+"=([^\\&]*)");
	var match = document.location.search.match(re);
	return (match != null) ? match[1] : "";
}

function isnull(value, defaultvalue) {
	return (value == "" || value == null || typeof(value) == "undefined") ? defaultvalue : value;
}
function formatnumber(value) {
	value = value+"";
	value = value.split("").reverse().join("");
	value = value.replace(/([0-9]{3})(?=[0-9])/g, "$1,");
	return value.split("").reverse().join("");
}

function formatJS(value) {
	return value.replace(/'/g, "\'");
}
function formatunits(value, single, multi, hidevalue) {
	if (value > 1) return ((hidevalue) ? "" : formatnumber(value)+" ")+multi;
	else if (value == 0) return "no "+multi;
	else return ((hidevalue) ? "" : formatnumber(value)+" ")+single;
}
function formattimestamptodatetime(timestamp) {
	if (typeof(timestamp) == "undefined") return "&nbsp;";
	function lpad(v) {
		v = v+"";
		return ((v.length == 1) ? "0" : "")+v;
	}
	var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
	var t = new Date(parseInt((timestamp+"").replace(/[^0-9]/g, ""), 10));
	return lpad(eval(t.getMonth()+1))+"/"+lpad(t.getDate())+"/"+t.getFullYear()+" "+lpad(t.getHours())+":"+lpad(t.getMinutes());
}

function lpad(v) {
	v = v+"";
	return ((v.length == 1) ? "0" : "")+v;
}

function formattimestamp(timestamp) {
	if (typeof(timestamp) == "undefined") return "&nbsp;";
	
	var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
	var t = new Date(parseInt((timestamp+"").replace(/[^0-9]/g, ""), 10));
	return lpad(eval(t.getMonth()+1))+"/"+lpad(t.getDate())+"/"+t.getFullYear();
//	return t.getDate()+" "+months[t.getMonth()]+" "+t.getFullYear();//+" "+lpad(t.getHours())+":"+lpad(t.getMinutes());
}
function formatmilliseconds(value) {
	return formatseconds(parseInt(value, 10)/1000);
}

function formatseconds(value) {
	value = parseInt(value);
	var h, m, s;
	h = Math.floor(value/3600);
	value -= h*3600;
	m = Math.floor(value/60);
	value -= m*60;
	s = value;
	return lpad(h)+":"+lpad(m)+":"+lpad(s);
}
function formatpercentage(value) {
	return value+"%";
}

function formattimestamptohours(timestamp) {
	try {
		var t = new Date(parseInt(timestamp.replace(/[^0-9]/g, ""), 10));
		var n = new Date();
		var h = Math.round((n-t)/(1000*60*60));
		if (isNaN(h)) return 100000;
		else return h;
	} catch (e) {
		return 100000;
	}
}
function formatactivity(value, clicks, hidestatus) {
	function setstatus(value) {
		return hidestatus ? "" : value;
	}
	if (typeof(clicks) != "undefined" && clicks == 0) return setstatus("Inactive: ")+"Never used before";
	
	if (value == 0) return setstatus("Action (Last activity: ")+"Few minutes ago"+setstatus(")");
	if (value < 24) return setstatus("Action (Last activity: ")+formatunits(value, "hour", "hours")+" ago"+setstatus(")");
	if (value < 72) return setstatus("Action (Last activity: ")+formatunits(Math.round(value/24), "day", "days")+" ago"+setstatus(")");
	else return "No activity for the past 3 days";
}

function formatinitcap(value, all) {
	if (value === null)
		return 0;
	var final = null;
	if (all) final = value.replace(/[\w]+/g, function(a, b) { return a.substring(0,1).toUpperCase()+a.substring(1); })
	else final = value.substring(0,1).toUpperCase()+value.substring(1);
	return final;
}

$(document).ready(function () {
    function set_height() {
        var maskHeight = $(document).height();
        var winH = $(window).height();
        var top_h = $('.bigboxtop').height();
        var bot_h = $('.bigboxbot').height();

        //var new_height=winH-top_h-bot_h-10;
        var new_height = winH - top_h - bot_h;
        
        $('.section .content').css({ 'height': new_height + 'px' })
    }

    set_height();

    if ($('.fixw').length) {
        var old_w = 0;
        $('.fixw').each(function () {
            var new_e = $(this).width();
            if (new_e > old_w) {
                old_w = new_e;
            }
        })
        $('.fixw').css('width', old_w + 'px')
    }

    function set_str_w() {
        $('.col-text').each(function () {
            var col_len = $(this).width();
            var col_h = $(this).height();
            if (col_h > 20) {
                var col_str = $(this).html();
                col_str = col_str.substring(0, col_len / 5);
                $(this).html(col_str + '...');

            }


        })
    }
    if ($('.col-text').length) {
        set_str_w();

    }

    var message = __rc("_message");
    var delay = __rc("_delay");

    if (message != null && message != "") Loader.show(message);
    if (delay != null && delay != "") Loader.hide(delay);

    __sc("_message", "");
    __sc("_delay", "");
});