function $(name) { return document.getElementById(name); }

var PopupManager = {};
PopupManager.popups = {};
PopupManager.visible = [];
PopupManager.current = null;

PopupManager.ClosePopup = function (id) {
    var position = PopupManager.visible.length;
    while (position--) {
        if (PopupManager.visible[position] == id) break;
    }
    for (var i = PopupManager.visible.length - 1; i > position - 1 && i >= 0; i--) {
        PopupManager.popups[PopupManager.visible[i]].Close();
        delete PopupManager.popups[PopupManager.visible[i]];
        PopupManager.visible.splice(i, 1);
    }
    if (PopupManager.visible.length > 0) {
        PopupManager.popups[PopupManager.visible[PopupManager.visible.length - 1]].Show();
    } else {
        $("popupoverlay").style.display = "none";
    }
}

PopupManager.ShowPopup = function (url, height, width, arguments) {
    PopupManager.current = arguments.popupArguments[0];

    var popup = new Popup(url, height, width, arguments);
    var id = popup.id;

    popup.arguments.popupArguments[0].close = function () { PopupManager.ClosePopup(id); };
    popup.arguments.popupArguments[0].popupManager = PopupManager;

    this.popups[id] = popup;
    popup = null;

    // show overlay if needed
    if ($("popupoverlay").style.display == "none") {
        $("popupoverlay").style.display = "";
        $("popupoverlay").style.width = document.body.clientWidth;
        $("popupoverlay").style.height = "100%";
        //document.all["popup_overlay"+pwid].style.width = "6000px";
    }

    // hide all other popups
    for (var i = 0, ii = this.visible.length; i < ii; i++) {
        this.popups[this.visible[i]].Hide();
    }
    this.popups[id].Create();
    this.visible.push(id);

    return { close: function () { PopupManager.ClosePopup(id); }, popupArguments: [], popup: null };
}

// override old hidePopup
var old_hidePopup = hidePopup;
hidePopup = function(pwid) 
{
    if (pwid == "_1") old_hidePopup(pwid);
    else PopupManager.ClosePopup(PopupManager.visible[PopupManager.visible.length-1]);
}

function Popup(url, height, width, arguments) {
    this.id = Math.round(Math.random()*100000);
    this.visible = false;

    this.url = url;
    this.height = height;
    this.width = width;
    this.arguments = arguments;
}
Popup.prototype.Create = function () {
	// create popup
	var output = [];
	output.push("<div class='popup_window' id='popupwindow_"+this.id+"'>");

	//var popupwindow = document.createElement("div");
	//popupwindow.className = "popup_window";
	//popupwindow.id = "popupwindow_" + this.id;
	//document.body.insertBefore(popupwindow, document.body.childNodes[0]);

	output.push('<iframe id="popupcontent_'+this.id+'" src="'+(this.url + ((this.url.match(/\?/)) ? "&" : "?") + "r=" + Math.random() * 10000)+'" scrolling="auto" frameborder="0"></iframe>');

	//var popupcontent = document.createElement('iframe');
	//popupcontent.id = "popupcontent_" + this.id;
	//popupwindow.appendChild(popupcontent);
	//popupcontent.arguments = this.arguments;

	//var id = this.id;
	//var popuparguments = this.arguments;
	//popupcontent.attachEvent("onload", function () {
	//	if (document.frames["popupcontent_" + id] != null)
	//		document.frames["popupcontent_" + id].setPopupArguments(popuparguments);
	//});

	//popupcontent.src = this.url + ((this.url.match(/\?/)) ? "&" : "?") + "r=" + Math.random() * 10000;
	//popupcontent.className = "popupIframeContent";
	//popupcontent.scrolling = "no";
	//popupcontent.frameBorder = "0";

	output.push("</div>");
	var div = document.createElement("div");
	document.body.insertBefore(div, document.body.childNodes[0]);
	div.innerHTML = output.join("");
	div = null;

	var id = this.id;
	var popuparguments = this.arguments;
	document.getElementById("popupcontent_" + id).attachEvent("onload", function () {
		if (document.frames["popupcontent_" + id] != null)
			document.frames["popupcontent_" + id].setPopupArguments(popuparguments);
	});

	this.Show();
}
Popup.prototype.Close = function () {
    var popupwindow = $("popupwindow_" + this.id);
    var popupcontent = $("popupcontent_" + this.id);

    if (popupwindow != null) {
        popupcontent.onload = null;
        popupcontent.detachEvent("onload");

        if (typeof (popupwindow.removeNode) != "undefined") {
            popupcontent.removeNode(true);
            popupwindow.parentNode.removeNode(true);
        } else {
            // todo: add cross browser support
        }
    }
    popupcontent = null;
    popupwindow = null;
}
Popup.prototype.Show = function() {
    $("popupwindow_" + this.id).parentNode.style.display = "";
    $("popupcontent_"+this.id).style.display = "";

    // shay todo: check why necessary?
    $("popupwindow_"+this.id).style.right = (document.body.clientWidth/2 - this.width/2) + 'px';
    $("popupwindow_"+this.id).style.bottom = (document.body.clientHeight/2 - this.height/2) + 'px';

    $("popupwindow_"+this.id).style.width = this.width;
    $("popupwindow_"+this.id).style.height = this.height;

    $("popupcontent_"+this.id).style.width = this.width;
    $("popupcontent_"+this.id).style.height = this.height;
}
Popup.prototype.Hide = function() {
    $("popupwindow_"+this.id).parentNode.style.display = "none";
    $("popupcontent_"+this.id).style.display = "none";   
}